﻿import java.awt.Font;
import java.io.*;
import javax.swing.*;

public class Basis {

	public static void filecopy(String quelle, String ziel) {
		    byte buffer[];																// Interner Puffer wird deklariert
		    try {
		       buffer = new byte[8192]; 												// der Puffer wird  erzeugt
		       FileInputStream src = new FileInputStream(quelle);			// InputStream erzeugt
		       FileOutputStream dest = new FileOutputStream(ziel);			// OutputStream erzeugt
		       int n;
		       do {
		    	   n = src.read(buffer);											// Ein Block wird gelesen 
		    	   if (n > 0) 	dest.write(buffer,0, n);								// Block schreiben
		      } while (n > 0);		  // n = -1 falls end of file erreicht
		      src.close();
		      dest.close();
		   }
		   catch (IOException io) {
			   ErrorBox("Fehler beim Kopieren der Datei"+getlineSeparator()+"Quelle: "+quelle+getlineSeparator()+"Ziel: "+ziel,"Kopieren");
		   }
	}

	public static String IStr2(int iZahl) {
		String s;
		java.text.NumberFormat nf = java.text.NumberFormat.getInstance();
		nf.setMinimumIntegerDigits(2);
		s = nf.format(iZahl);
		return s;
	} // IStr2

	public static String IStr3(int iZahl) {
		String s;
		java.text.NumberFormat nf = java.text.NumberFormat.getInstance();
		nf.setMinimumIntegerDigits(3);
		s = nf.format(iZahl);
		return s;
	} // IStr3

	// Damit braucht man nicht die Konstanten aus JOptionPane referenzieren
	public static final int YES = 1;
	public static final int NO = 2;
	public static final int ESC = 3;

	// liefert / oder \
	public static String getfileSeparator() {
		java.util.Properties pHash = System.getProperties();
		String sErg = (String) pHash.get("file.separator");
		return sErg;
	} // getfileSeparator

	// liefert :
	public static String getpathSeparator() {
		java.util.Properties pHash = System.getProperties();
		String sErg = (String) pHash.get("path.separator");
		return sErg;
	} // getpathSeparator

	// liefert \n bzw. \r\n
	public static String getlineSeparator() {
		java.util.Properties pHash = System.getProperties();
		return (String) pHash.get("line.separator");
	} // getlineSeparator

	// c:\einstellungen oder /home
	public static String getuserHome() {
		java.util.Properties pHash = System.getProperties();
		String sErg = (String) pHash.get("user.home");
		return sErg;
	} // getuserHome

	public static String getuserName() {
		java.util.Properties pHash = System.getProperties();
		String sErg = (String) pHash.get("user.name");
		return sErg;
	} // getuserName

	// aktuelle Verzeichnis
	public static String getuserDir() {
		java.util.Properties pHash = System.getProperties();
		String sErg = (String) pHash.get("user.dir");
		return sErg;
	} // getuserDir

	public static String getHex(int value) {
		String sItem = Integer.toHexString(value);
		if (sItem.length() < 1)
			sItem = "0" + sItem;
		return sItem;
	}

	public static void ErrorBox(String sMessage, String sTitle) {
		JOptionPane.showConfirmDialog(null, sMessage, sTitle, JOptionPane.DEFAULT_OPTION, JOptionPane.ERROR_MESSAGE); // Symbol
		/*
		 * Optionen der Schalter: DEFAULT_OPTION Ok YES_NO_OPTION YES_NO_CANCEL_OPTION
		 * OK_CANCEL_OPTION
		 */
		/*
		 * Symbole: ERROR_MESSAGE INFORMATION_MESSAGE WARNING_MESSAGE QUESTION_MESSAGE
		 * PLAIN_MESSAGE
		 */

	} // ErrorBox

	/**
	 * description: Zeigt eine Nachricht an
	 * 
	 * @see Message, Yes-No, Yes-No-Esc, Ok-Esc
	 *
	 * @version 1.0 07.07.2002
	 * @author Michael Wilhelm HS Harz, FB AI
	 * @param String sTitle, String sMessage
	 * @return keinen
	 * @exception keine
	 */
	public static void MessageBox(String sMessage, String sTitle) {
		JOptionPane.showConfirmDialog(null, sMessage, sTitle, JOptionPane.DEFAULT_OPTION,
				JOptionPane.INFORMATION_MESSAGE); // Symbol
		/*
		 * Optionen der Schalter: DEFAULT_OPTION Ok YES_NO_OPTION YES_NO_CANCEL_OPTION
		 * OK_CANCEL_OPTION
		 */
		/*
		 * Symbole: ERROR_MESSAGE INFORMATION_MESSAGE WARNING_MESSAGE QUESTION_MESSAGE
		 * PLAIN_MESSAGE
		 */

	} // Message

	/**
	 * description: Zeigt einen Ja-Nein-Dialog
	 * 
	 * @see Message, Error, Yes-No-Esc, Ok-Esc
	 *
	 * @version 1.0 07.07.2002
	 * @author Michael Wilhelm HS Harz, FB AI
	 * @param String sTitle, String sMessage
	 * @return boolean
	 * @exception keine
	 */
	public static boolean YesNo(String sTitle, String sMessage) {
		int retcode;
		retcode = JOptionPane.showConfirmDialog(null, sMessage, sTitle, JOptionPane.YES_NO_OPTION,
				JOptionPane.QUESTION_MESSAGE); // Symbol

		switch (retcode) {
		case JOptionPane.YES_OPTION:
			// ja, Änderungen speichern
			return true;
		case JOptionPane.NO_OPTION:
			return false;
		case JOptionPane.CANCEL_OPTION:
		default:
			// abbrechen
			return false;
		}
	} // YesNo

	/**
	 * description: Zeigt einen Ja-Nein-Abbruch-Dialog
	 * 
	 * @see Message, Error, Yes-No, Ok-Esc
	 *
	 * @version 1.0 07.07.2002
	 * @author Michael Wilhelm HS Harz, FB AI
	 * @param String sTitle, String sMessage
	 * @return int YES_OPTION, NO_OPTION, CANCEL_OPTION
	 * @exception keine
	 */
	public static int YesNoEsc(String sTitle, String sMessage) {
		int retcode;
		retcode = JOptionPane.showConfirmDialog(null, sMessage, sTitle, JOptionPane.YES_NO_CANCEL_OPTION,
				JOptionPane.QUESTION_MESSAGE); // Symbol

		switch (retcode) {
		case JOptionPane.YES_OPTION:
			// ja, Änderungen speichern
			return YES;
		case JOptionPane.NO_OPTION:
			return NO;
		case JOptionPane.CANCEL_OPTION:
		default:
			return ESC;
		}
	} // YES NO ESC

	/**
	 * description: Eingabe eines Strings
	 * 
	 * @see getInput
	 *
	 * @version 1.0 07.07.2002
	 * @author Michael Wilhelm HS Harz, FB AI
	 * @param String sTitle, String sMessage
	 * @return String
	 * @exception keine
	 */
	public static String getInput(String sTitle, String sMessage) {
		return JOptionPane.showInputDialog(null, sTitle, sMessage, 1);
	} // getInput

	/**
	 * description: Eingabe eines Strings mit Vorgabe
	 * 
	 * @see getInput
	 *
	 * @version 1.0 07.07.2002
	 * @author Michael Wilhelm HS Harz, FB AI
	 * @param String sTitle, String sMessage, String sInput
	 * @return String
	 * @exception keine
	 */
	public static String getInput(String sTitle, String sMessage, String sInput) {
		return (String) JOptionPane.showInputDialog(null, sMessage, sTitle, JOptionPane.PLAIN_MESSAGE, null, null,
				sInput);
	} // getInput

	// Datei Methoden

	// Beispiel
	// szMom = bas.ChangeFileExt(szUFileName, ".MOM");

	/**
	 * description: ändert die Extention eines Dateinamens (TXT bzw. DAT)
	 * 
	 * @see #CheckFileName
	 * @see #getFileExt Ändern der Dateiwerweiterung TXT -> DAT
	 *
	 * @version 1.0 07.07.2002
	 * @author Michael Wilhelm HS Harz, FB AI
	 * @param String sFileName, String sExt
	 * @return String
	 * @exception keine
	 * @see #CheckFileName
	 * @see #ChangeFileExt
	 * @see #getFileName extrahiert den Dateinamen ohne Pfad
	 * @see #FileExists
	 */
	// liefert den Punkt mit z.B. .txt
	public static String changeFileExt(String filename, String sExt) {
		String sErgFile;
		int k;
		sErgFile = "";
		File f = null;
		// File.pa
		try {
			// eventuell kann auch f.pathSeparatorChar verwendet werden
			// suche letzten Punkt
			k = filename.lastIndexOf(".");
			if (k == -1) { // kein Punkt vorhanden
				return new String(filename + sExt);
			} else {
				int n = filename.length();
				// beginIndex EndIndex
				sErgFile = filename.substring(0, k + 1); // zählt von 0
				return new String(sErgFile + sExt);
			}

		} catch (Exception e) {
		}
		return sErgFile;
	}
	// Beispiel
	// szMom = bas.getFileExt(szUFileName);
	// szMom = ".MOM"

	/**
	 * description: holt die Extention eines Dateinamens (TXT bzw. DAT)
	 * 
	 * @see #CheckFileName
	 * @see #changeFileExt
	 *
	 * @version 1.1 31.01.2006
	 * @author Michael Wilhelm HS Harz, FB AI
	 * @param String sFileName, String sExt
	 * @return String
	 * @exception keine
	 * @see #CheckFileName
	 * @see #ChangeFileExt
	 * @see #getFileName extrahiert den Dateinamen ohne Pfad
	 * @see #FileExists
	 */
	// besser mit lastIndexOf(String str)
	public static String getFileExt(String sFileName) {
		int k, i, n;
		n = sFileName.length();
		// suche von hinten erstes Auftreten eines Punktes
		k = sFileName.lastIndexOf(".");
		if (k == -1) // kein Punkt vorhanden
			return new String("");
		else {
			// substring zählt von NULL
			// Anfangsindex EndIndex
			String s;
			s = sFileName.substring(k, n);
			return sFileName.substring(k, n);
		}
	} // getFileExt

	/**
	 * GetFileNameExt description: holt den Namen und die Extention eines
	 * Dateinamens, ohne Pfad
	 * 
	 * @return String Name+Ext
	 * @param String sFileName
	 * @exception none
	 * @version 1.1, 31.01.2006
	 * @author Michael Wilhelm HS Harz, FB AI
	 * @use Example
	 * @see #CheckFileName
	 * @see #ChangeFileExt
	 * @see #getFileName extrahiert den Dateinamen ohne Pfad
	 * @see #FileExists
	 */
	public static String getFileNameExt(String filename) {
		int k, n;
		n = filename.length();
		k = filename.lastIndexOf(getfileSeparator()); // / oder \
		if (k == -1) {
			return filename;
		} else {
			// beginIndex endIndex
			return filename.substring(k + 1, n); // ?????? n-1 ist zu klein
		}
	} // getFileNameExt

	/**
	 * GetFileNameExt description: holt nur den Namen, mit Pfad, ohne Extention
	 * 
	 * @return String Name
	 * @param String sFileName
	 * @exception none
	 * @version 1.1, 31.01.2006
	 * @author Michael Wilhelm HS Harz, FB AI
	 * @use Example
	 * @see #CheckFileName
	 * @see #ChangeFileExt
	 * @see #getFileNameExt
	 * @see #FileExists
	 */
	public static String getFileName(String sFileName) {
		int k, i, n;
		n = sFileName.length();
		k = sFileName.lastIndexOf(".");
		if (k == -1)
			return sFileName;
		else
			return sFileName.substring(0, k); // ohne Punkt
	} // getFileName

	/**
	 * FileExists description: prüft, ob die Datei existiert
	 * 
	 * @return boolean
	 * @param String sFileName
	 * @exception none
	 * @version 1.1, 31.01.2006
	 * @author Michael Wilhelm HS Harz, FB AI
	 * @use Example
	 * @see #CheckFileName
	 * @see #ChangeFileExt
	 * @see #getFileNameExt
	 */
	public static boolean FileExists(String filename) {
		File f = null;
		try {
			// System.out.println("filename: "+filename);
			f = new File(filename);
			if (f.exists())
				return true;
			else
				return false;
		} catch (Exception e) {
			return false;
		}
	} // FileExists

	public static String getPath(String filename) {
		int k, n;
		n = filename.length();
		k = filename.lastIndexOf(getfileSeparator());
		// System.out.println("filename: "+filename);
		// System.out.println("k: "+k);
		if (k == -1) {
			return "";
		} else {
			// beginIndex endIndex
			return filename.substring(0, k + 1); // ?????? n-1 ist zu klein
		}

	}

	public static void setJMenuFont(boolean bTop, JMenu main, int size) {
		if (bTop)
			main.setFont(new Font("Arial", Font.BOLD, size));
		else
			main.setFont(new Font("Arial", Font.PLAIN, size));
		JMenuItem mn;
		for (int j = 0; j < main.getItemCount(); j++) {
			mn = main.getItem(j);
			// Abfrage auf Separator, sonst Absturz
			if (mn instanceof JMenuItem)
				mn.setFont(new Font("Arial", Font.PLAIN, size));
			if (mn instanceof JMenu) {
				JMenu menu = (JMenu) mn;
				setJMenuFont(false, menu, size);
			}
		}
	}

	public static void setMenueFont(JMenuBar menuBar1, boolean bTop, int size) {
		for (int i = 0; i < menuBar1.getMenuCount(); i++) {
			setJMenuFont(bTop, menuBar1.getMenu(i), size);
		}
	}

	// centerScreen(this, null);
	/**
	 * centerScreen description: Zentriert das Fenster
	 *
	 * @return none
	 * @param java.awt.Window frame, java.awt.Dimension preset
	 * @exception none
	 * @version 1.1, 31.01.2006
	 * @author Michael Wilhelm HS Harz, FB AI
	 */
	static public void centerScreen(java.awt.Window frame, java.awt.Dimension preset) {
		java.awt.Dimension screenSize = java.awt.Toolkit.getDefaultToolkit().getScreenSize();
		if (preset == null)
			preset = frame.getSize();
		if (preset.height > screenSize.height)
			preset.height = screenSize.height;
		if (preset.width > screenSize.width)
			preset.width = screenSize.width;
		// set new pos:
		frame.setBounds((screenSize.width - preset.width) >> 1, (screenSize.height - preset.height) >> 1, preset.width,
				preset.height);
	} // centerScreen

}
