﻿import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;  // modify

import java.io.*;

public abstract class ChildForm  extends JInternalFrame {
  
  private String _sFilename=SingVar.C_NONAME;
  private String _Caption="";
  
  private boolean _bModify=false;
  
  private JScrollPane paneLeft = null;
  private JScrollPane paneRight = null;
  protected JTextArea _lineeditor = new JTextArea();
  protected JTextArea _editor = new JTextArea();
  
  public JTextArea getEditor() {
    return _editor;
  }

  
  public String getFilename() {
    return _sFilename;
  }
  
  public ChildForm() {
    this(SingVar.C_NONAME);
    updateOptionSession();
  }
  
  public void updateOptionSession() {
    SingVar instance = SingVar.getInstance();  
    _editor.setTabSize( instance.getTabLength() );
    _editor.setFont( new Font("Courier New", Font.PLAIN,instance.getFontsize()   ) );
  }
  
  
  public ChildForm(String sFilename) {
    _sFilename = sFilename;
    if (sFilename.equals("") )
      _Caption = SingVar.C_NONAME;
    else
      _Caption = sFilename;
    setGUI();
    setVisible(true);  
    _editor.setLineWrap(false);
    _editor.setTabSize(2);
    _editor.setFont( new Font("Courier New", Font.PLAIN,18) );
    
    _lineeditor.setLineWrap(false);
    _lineeditor.setFont( new Font("Courier New", Font.PLAIN,18) );
    
    setDefaultCloseOperation( JFrame.DO_NOTHING_ON_CLOSE );    
    // installLnF();
  }

  
  
  // wird aufgerufen wird Clientfenster, abgeleitet
  private void setGUI() {
    setClosable(true);
    setIconifiable(true);
    setMaximizable(true);
    setResizable(true);
    setTitle( _Caption );

   setLayout( new BorderLayout() );
   JPanel panelEditoren = new JPanel();
   panelEditoren.setLayout(new GridBagLayout());
   
   paneLeft = new JScrollPane(_lineeditor);
   panelEditoren.add(paneLeft,
           new GridBagConstraints(0, 0, 1, 1, 10.0, 100.0,
           GridBagConstraints.EAST, GridBagConstraints.BOTH,
           new Insets(0,5,0,0), 0, 0));
   
   _lineeditor.setForeground(Color.BLUE);
   _lineeditor.setBackground(new Color(230,230,230));
   
   paneRight = new JScrollPane(_editor);
   panelEditoren.add(paneRight,
           new GridBagConstraints(1, 0, 1, 1, 100.0, 100.0,
           GridBagConstraints.EAST, GridBagConstraints.BOTH,
           new Insets(0,0,0,5), 0, 0));
   
   StringBuilder sb = new StringBuilder();
   for (int i=1; i<200; i++) {
	   sb.append(Basis.IStr3(i));
	   sb.append(Basis.getlineSeparator());
   }
   _lineeditor.setText(sb.toString());
   
   add( panelEditoren, BorderLayout.CENTER);
   
  
   
   loadFile();
   _editor.setCaretPosition(0);
   _lineeditor.setCaretPosition(0);
   
   paneRight.getVerticalScrollBar().addAdjustmentListener(new AdjustmentListener(){

       @Override
       public void adjustmentValueChanged(AdjustmentEvent e) {
    	   JScrollBar scbarRight = paneRight.getVerticalScrollBar();
    	   BoundedRangeModel 	modelRight = scbarRight.getModel();
           
    	   JScrollBar scbarLeft = paneRight.getVerticalScrollBar();
    	   BoundedRangeModel 	modelLeft = scbarLeft.getModel();
    	   modelLeft.setValue(modelRight.getValue());
    	   scbarLeft.setValue(scbarRight.getValue());
    	   scbarLeft.updateUI();
    	   //scbarLeft.updateUI();
           System.out.println("Right:"+scbarRight.getValue());
    	   System.out.println("Left:"+scbarLeft.getValue());
    	   //scbarLeft.setValueIsAdjusting(false);
    	   //scbarLeft.setValueIsAdjusting(true);
    	   
    	  // System.out.println("minR:"+model.getMinimum());
    	   // System.out.println("maxR:"+model.getMaximum());
           
    	   // System.out.println("min:"+modelLeft.getMinimum());
    	   //System.out.println("max:"+modelLeft.getMaximum());
           
       }});      
   
    this.addInternalFrameListener(new InternalFrameAdapter(){
              @Override
              public void internalFrameClosing(InternalFrameEvent e) {
                                    window_close();
              }
          });	  
   
   _editor.getDocument().addDocumentListener( new DocumentListener() {
            @Override
            public void insertUpdate(DocumentEvent e) {
               _bModify=true;
            }
            @Override
            public void removeUpdate(DocumentEvent e) {
              _bModify=true;
            }
            @Override
            public void changedUpdate(DocumentEvent e) {
                // _bModify=true;
            }
        }      
     );     
  }  // setGUI
  
    private void window_close() {
            if (_bModify) {
                int retcode;
                retcode = Basis.YesNoEsc("Beenden des Dialogfensters","Wollen Sie die Datei speichern?");
                        switch (retcode) {
                          case Basis.YES: saveFile();                                         
                                          Basis.MessageBox("Datei gespeichert, Fenster wird geschlossen", "Meldung");
                                          break;
                          case Basis.NO: Basis.MessageBox("Datei nicht gespeichert, Fenster wird geschlossen", "Meldung");
                                          break;
                          case Basis.ESC: Basis.MessageBox("Abbruch!", "Meldung");
                                          return;
                }			
            }            
            dispose();
    }  // window_close
  
  
  private void loadFile() {
    FileInputStream fin;
    InputStreamReader iin;
    LineNumberReader din;
    if (!_sFilename.equals(SingVar.C_NONAME))   {
      if (Basis.FileExists(_sFilename))    {
        String sLine, sText="";
        int i=0;
        try {
          fin = new FileInputStream(_sFilename);
          iin = new InputStreamReader(fin);
          din = new LineNumberReader(iin);
          while  ( din.ready()  ) {
            int b = fin.read();
            char ch = (char) b;
            sText = sText + ch;
            
            /*sLine = din.readLine();
            i++;
            if (i==1)
              sText = sLine;
            else
              sText = sText + Basis.getlineSeparator() + sLine;
              * 
              */
          }
          _editor.setText(sText);
        }
        catch (IOException e) {
              System.err.println("IOException: " + e);
        }
      }
      else {
        _editor.setText("");
      }
    }
  }  // loadFile
  
  public void saveAs(String sFilename) {
	  String ext = Basis.getFileExt(_sFilename).toLowerCase();
	  if (ext.equals(".xhtml") || ext.equals(".html") || ext.equals(".htm") || ext.equals(".php")) {
		  changeCSSFile(_sFilename, sFilename);
	  }
    _sFilename = sFilename;
    setTitle( _sFilename );
    // Change xhtml den CSS
    saveFile();
  }
  
  public void changeCSSFile(String oldHTMLFilename, String newHTMLFilename) {
      String path, oldName, newName, ext;
      oldName=Basis.getFileNameExt( Basis.changeFileExt(oldHTMLFilename, "css") );
      newName=Basis.getFileNameExt( Basis.changeFileExt(newHTMLFilename, "css") );
      // suche   href="Vorl_jq8.css"    ersetze  durch href="Vorl_jq9.css"
      String s1 = _editor.getText();
      String s2 = "href=\"" + oldName + "\"";
      int i = _editor.getText().indexOf("href=\"" + oldName + "\"");
      if (i > 0) {
          _editor.setText( _editor.getText().replace("href=\"" + oldName + "\"", "href=\"" + newName + "\"") );
          _bModify = true;
      }
  }  
  
  
  public void saveFile() {
    String sText = _editor.getText();
    String[] sLines = sText.split(Basis.getlineSeparator());
    try {
      FileOutputStream fout = new FileOutputStream(_sFilename);
      PrintStream p = new PrintStream(fout);
      for (String sLine : sLines) {
        p.println( ChangeUmlaute(sLine) );
      }
      p.close();
      fout.close();              
      _bModify=false;
    }
    catch (IOException ee) {
        System.err.println("IOException: " + ee);
    }
  }  // saveFile
    
  
    
    String ChangeUmlaute(String sText) 
    {
      sText = ChangeUmlaut("Ä","&#196;", sText);
      sText = ChangeUmlaut("ä","&#228;",sText);
      sText = ChangeUmlaut("Ö","&#214;",sText);
      sText = ChangeUmlaut("ö","&#246;",sText);
      sText = ChangeUmlaut("Ü","&#220;",sText);
      sText = ChangeUmlaut("ü","&#252;",sText);
      sText = ChangeUmlaut("ß","&#223;",sText);
      return sText;
    }


    String ChangeUmlaut(String sChar, String sNewChar, String sText)  {
        int i;
        int al1, al2;
        int startindex;        
        al1 = sText.indexOf("alert");
        if (al1 >= 0)
            al2 = sText.indexOf(")", al1 + 4);
        else
            al2 = -1;

      i = sText.indexOf(sChar);  // CurrentCultureIgnoreCase
      while (i>=0) {

          //if (((i >= ji1) && (i <= ji2)) || ((i >= pi1) && (i <= pi2)) || ((i >= qi1) && (i <= qi2)))
          if ( (al1>=0)   && (i >= al1) && (i <= al2) )
              startindex = i + 1;
          else
          {            
              sText = sText.substring(0, i) + sNewChar + sText.substring(i+1); // funktioniert nur, wenn sChar Laenge 1 ist 
              startindex = i + 1;
          }
        //  al1 = sText.IndexOf("alert", startindex, StringComparison.CurrentCultureIgnoreCase);
        //if (al1 >= 0)
        //    al2 = sText.IndexOf(")", al1 + 4, StringComparison.CurrentCultureIgnoreCase);
        //else
        //    al2 = -1;
          i = sText.indexOf(sChar, startindex);             
      }  // ChangeUmlaut      
      return sText;
    }  // ChangeUmlaut
    
    public void cut() {
      _editor.cut();
    }
    public void copy() {
      _editor.copy();
    }
    public void paste() {
      _editor.paste();
    }
    public void selectAll() {
      _editor.selectAll();
    }
    
    public abstract void setFontSize(int fontsize);    
    
}
