import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

// Packages fuer Opendialog
import java.io.File;
import java.io.IOException;

import javax.swing.event.InternalFrameEvent;
import javax.swing.filechooser.*;

import javax.swing.event.InternalFrameListener;

import java.awt.datatransfer.*;


public class IHTML extends JFrame  implements ActionListener  {
	
	private int fontsize=18;
	
	private SingVar singvar = null;
	private boolean isWindows=true;
	private boolean isOS=false;
	
	private int CTRL=ActionEvent.CTRL_MASK;
	

  private JDesktopPane _desktopPane = new JDesktopPane();  
  
  private JMenuBar menuBar1;   // MenueContainer
  private JMenu mainFile;      // Hauptmenue
  private JMenuItem mnNew;     // Menueeintrag
  private JMenuItem mnOpen;    
  private JMenuItem mnSave;    
  private JMenuItem mnSaveAs;    
  
  private JMenuItem mnSaveAllFiles;    
  private JMenuItem mnCalc;    
  private JMenuItem mnDos;    
  private JMenuItem mnNotepad;    
  private JMenuItem mnExplorer;    

  private JMenuItem mnClose;   

  private JMenu mainEdit;
  private JMenuItem mnCut;  
  private JMenuItem mnCopy; 
  private JMenuItem mnPaste;
  private JMenuItem mnSelectAll;  
  
  JMenu mainFont = new JMenu("Font");
  
  private JMenu mainRun;
  private JMenuItem mnStandard;  
  private JMenuItem mnSafari; 
  private JMenuItem mnFirefox; 
  private JMenuItem mnOpera;
  private JMenuItem mnChrome;  
  private JMenuItem mnBrowser5;  
  private JMenuItem mnBrowser6;  
  
  
  private JMenu mainWindows;        // HauptMenue
  private JMenuItem mnPrevWindows;  // Menueeintrag
  private JMenuItem mnNextWindows; 
  private JMenuItem mnTile;        
  private JMenuItem mnTileVertical;    
  private JMenuItem mnTileHorizontal;
  private JMenuItem mnCascade;     
  
  private JMenu mainLook_Feel;
  private JMenuItem mnLook_Feel_Windows;
  private JMenuItem mnLook_Feel_Motif;
  private JMenuItem mnLook_Feel_Metal;
  private JMenuItem mnLook_Feel_Nimbus;
   
  private JMenu mainOptions;  
  private JMenuItem mnOption; 
  private JMenuItem mnProgInfo; 
  
  JButton bnOpen = new JButton("Open");
  JButton bnNew = new JButton("New");
  JButton bnSave = new JButton("Save");
  JButton bnSaveAll = new JButton("Save All");

  JButton bnSafari = new JButton("Safari");
  JButton bnFirefox = new JButton("Firefox");
  JButton bnOpera = new JButton("Opera");
  JButton bnChrome = new JButton("Chrome");
  JButton bnBrowser5 = new JButton("5. Browser");
  JCheckBox chkRunTab0 = new JCheckBox("run the first tab");
  
  
  
  public IHTML() {
    this.setSize( 970, 700);
    setTitle( "i HTML");
    setDefaultCloseOperation( JFrame.EXIT_ON_CLOSE );
    singvar = SingVar.getInstance();
    singvar.readProperties();
    String os = System.getProperty("os.name");  //  os.arch  amd64  ia64   x86     Windows 10
	System.out.println("os: "+os);
    
	  if (os.equals("Windows 10")  || os.equals("Windows 7")) {
	        isWindows=true;
		  }
		  else {
			  isWindows=false;
		  }    
	  if (os.indexOf("MAC")>=0) {
	        isOS=true;
	        CTRL=ActionEvent.META_MASK;
		  }
		  else {
			  isOS=false;
		  }    
	  
    this.fontsize = singvar.getFontsize();
    setGUI();
  }

  public void setGUI() {
      // BorderLayout setzen
    this.getContentPane().setLayout( new BorderLayout() );

      // Variable DesktopPane einfuegen
      // in ihr werden alle Clientfenster eingefuegt
    this.getContentPane().add(  _desktopPane, BorderLayout.CENTER);
    setMenus();
    setToolBars();
    setFontsize(this.fontsize);
   // installLnF();
      try {
          UIManager.setLookAndFeel("com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel");
          SwingUtilities.updateComponentTreeUI(this.getContentPane() );  // alles neuzeichnen
          return;
      }
      catch (Exception elook) {
      }
    
  }  // setGUI
  
    // setzt die Menues
  private void setMenus() {
    menuBar1 = new JMenuBar();

      // DATEI
    mainFile = new JMenu("File");
    mnNew = new JMenuItem("New");
    mnOpen = new JMenuItem("Open");
    mnSave = new JMenuItem("Save");
    mnSaveAs = new JMenuItem("Save as");
        
    mnSaveAllFiles = new JMenuItem("Save all files");
    mnCalc = new JMenuItem("calc");
    mnDos = new JMenuItem("Dos");
    mnNotepad = new JMenuItem("Notepad");
    mnExplorer = new JMenuItem("Explorer");
    
    mnClose = new JMenuItem("Close");

      // Event definieren
    mnNew.addActionListener(this);
    mnNew.setActionCommand("NewFile");
      // Short Key definieren  STRG+N
    mnNew.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_N, CTRL));
    mainFile.add(mnNew);

      // Event definieren
    mnOpen.addActionListener(this);
    mnOpen.setActionCommand("OpenFile");
      // Short Key definieren  STRG+O
    mnOpen.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_O, CTRL));
     // Menueeintraege zum mainFile hinzufuegen
    mainFile.add(mnOpen);

    mnSave.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_S, CTRL));
    mnSave.addActionListener(this);
    mnSave.setActionCommand("SaveFile");

    mnSaveAs.addActionListener(this);
    mnSaveAs.setActionCommand("SaveAsFile");
    mnSaveAs.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_F12,0));
    
    
    mnSaveAllFiles.addActionListener(this);
    mnCalc.addActionListener(this);
    mnDos.addActionListener(this);
    mnNotepad.addActionListener(this);
    mnExplorer.addActionListener(this);
    
    mnSaveAllFiles.setActionCommand("SaveAllFiles");
    mnCalc.setActionCommand("Calc");
    mnDos.setActionCommand("Dos");
    mnNotepad.setActionCommand("Notepad");
    mnExplorer.setActionCommand("Explorer");
    
    if (!isWindows) {
    	mnNotepad.setEnabled(false);
    	mnExplorer.setEnabled(false);
    }
    
    
    mainFile.add(mnSave);
    mainFile.add(mnSaveAs);
    mainFile.add(mnSaveAllFiles);
    mainFile.addSeparator();
    mainFile.add(mnCalc);
    mainFile.add(mnDos);
    mainFile.add(mnNotepad);
    mainFile.add(mnExplorer);
    
    mainFile.addSeparator();

    // --------------------------
      // Event definieren
    mnClose.addActionListener(this);
    mnClose.setActionCommand("Close");
    mainFile.add(mnClose);

      // Hauptmenue FILE in den MenueBar einfuegen
    menuBar1.add(mainFile);

    
    mainEdit = new JMenu("Edit");
    menuBar1.add(mainEdit);
    mnCut = new JMenuItem("Cut");
    mnCopy = new JMenuItem("Copy");
    mnPaste = new JMenuItem("Paste");
    mnSelectAll = new JMenuItem("Select all");

    mnCut.addActionListener(this);
    mnCut.setActionCommand("Cut");
    mnCopy.addActionListener(this);
    mnCopy.setActionCommand("Copy");
    mnPaste.addActionListener(this);
    mnPaste.setActionCommand("Paste");
    mnSelectAll.addActionListener(this);
    mnSelectAll.setActionCommand("SelectAll");
    
    mainEdit.add(mnCut);
    mainEdit.add(mnCopy);
    mainEdit.add(mnPaste);
    mainEdit.add(mnSelectAll);
    
    
    menuBar1.add(mainFont);
    for (int i=8; i<=40; i+=2) {
    	MyJCheckBoxMenuItem mnFont = new MyJCheckBoxMenuItem(Integer.toString(i)+" pg",i);    	
    	mnFont.setActionCommand("fontsize");
    	mnFont.addActionListener(this);
    	mainFont.add(mnFont);
    }
    
    //-------------------
    mainRun = new JMenu("Run");
    menuBar1.add(mainRun);
    mnStandard = new JMenuItem("Standard Browser");
    mnSafari = new JMenuItem("Safari");
    mnFirefox = new JMenuItem("Firefox");
    mnOpera = new JMenuItem("Opera");
    mnChrome = new JMenuItem("Chrome");
    mnBrowser5 = new JMenuItem("5. Browser");
    
    mainRun.add(mnStandard);
    mainRun.add(mnSafari);
    mainRun.add(mnFirefox);
    mainRun.add(mnOpera);
    mainRun.add(mnChrome);
    mainRun.add(mnBrowser5);

    mnStandard.addActionListener(this);
    mnStandard.setActionCommand("StandardBrowser");
    mnSafari.addActionListener(this);
    mnSafari.setActionCommand("Safari");
    mnFirefox.addActionListener(this);
    mnFirefox.setActionCommand("Firefox");
    mnOpera.addActionListener(this);
    mnOpera.setActionCommand("Opera");
    mnChrome.addActionListener(this);
    mnChrome.setActionCommand("Chrome");
    mnBrowser5.addActionListener(this);
    mnBrowser5.setActionCommand("Browser5");

    // ----------------
    // Menue Windows
    mainWindows = new JMenu("Windows");
    mnPrevWindows = new JMenuItem("Previous window");
    mnNextWindows = new JMenuItem("Next window");
    
    mnCascade = new JMenuItem("Caskade");    
    mnCascade.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_F6, 0));

    mnTile = new JMenuItem("Tile");
    mnTile.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_F7, 0));

    mnTileVertical = new JMenuItem("Tile Vertical");
    mnTileVertical.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_F8, 0));

    mnTileHorizontal = new JMenuItem("Tile Horizontal");
    mnTileHorizontal.setAccelerator( KeyStroke.getKeyStroke(KeyEvent.VK_F9, 0));
      // Event definieren

      // Event definieren
    mnCascade.addActionListener(this);
    mnCascade.setActionCommand("Cascade");
    mnTile.addActionListener(this);
    mnTile.setActionCommand("Tile");
    mnTileVertical.addActionListener(this);
    mnTileVertical.setActionCommand("TileVertical");
    mnTileHorizontal.addActionListener(this);
    mnTileHorizontal.setActionCommand("TileHorizontal");
    
      // MenueEintraege definieren
    mainWindows.add(mnPrevWindows);
    mainWindows.add(mnNextWindows);
    mainWindows.addSeparator();
    mainWindows.add(mnCascade);
    mainWindows.add(mnTile);
    mainWindows.add(mnTileVertical);
    mainWindows.add(mnTileHorizontal);
    menuBar1.add(mainWindows);
    
    mainLook_Feel = new JMenu("Look & Feel");
    menuBar1.add(mainLook_Feel);
    
    
    mnLook_Feel_Windows = new JMenuItem("Windows");
    mnLook_Feel_Motif = new JMenuItem("Motif");
    mnLook_Feel_Metal = new JMenuItem("Metal");
    mnLook_Feel_Nimbus = new JMenuItem("Nimbus");

    mainLook_Feel.add(mnLook_Feel_Windows);
    mainLook_Feel.add(mnLook_Feel_Metal);
    mainLook_Feel.add(mnLook_Feel_Motif);
    mainLook_Feel.add(mnLook_Feel_Nimbus);
    
    mnLook_Feel_Windows.addActionListener( this );
    mnLook_Feel_Motif.addActionListener( this );
    mnLook_Feel_Metal.addActionListener( this );
    mnLook_Feel_Nimbus.addActionListener( this );
    
    mnLook_Feel_Windows.setActionCommand("Windows");
    mnLook_Feel_Motif.setActionCommand("Motif");
    mnLook_Feel_Metal.setActionCommand("Metal");
    mnLook_Feel_Nimbus.setActionCommand("Nimbus");

    mainOptions = new JMenu("Options");
    menuBar1.add(mainOptions);            
    mnOption = new JMenuItem("Properties");
    mainOptions.add(mnOption);
    mnOption.addActionListener( this );
    mnOption.setActionCommand("showOptions");
  
    mnProgInfo = new JMenuItem("Program-Info");
    mainOptions.add(mnProgInfo);
    mnProgInfo.addActionListener( this );
    mnProgInfo.setActionCommand("ProgInfo");
    
    
    
    
    this.setJMenuBar(menuBar1);
    Basis.setMenueFont( menuBar1, true, this.fontsize);  // leider doppelt vorhanden

    
  } // setMenus


  private void setToolBars() {
    JToolBar toolBar = new JToolBar();

    
    toolBar.add(bnOpen);
    bnOpen.addActionListener(this);
    bnOpen.setActionCommand("OpenFile");
 

    bnNew.addActionListener(this);
    bnNew.setActionCommand("NewFile");
    toolBar.add(bnNew);

    bnSave.addActionListener(this);
    bnSave.setActionCommand("SaveFile");
    toolBar.add(bnSave);    

    bnSaveAll.addActionListener(this);
    bnSaveAll.setActionCommand("SaveAllFiles");
    toolBar.add(bnSaveAll);    

    toolBar.addSeparator( new Dimension(20,10));
    
    toolBar.add(bnSafari);
    toolBar.add(bnFirefox);    
    toolBar.add(bnOpera);    
    toolBar.add(bnChrome);    
    toolBar.add(bnBrowser5);
    
    bnSafari.addActionListener(this);
    bnFirefox.addActionListener(this);
    bnOpera.addActionListener(this);
    bnChrome.addActionListener(this);
    bnBrowser5.addActionListener(this);
    
    
    bnSafari.setActionCommand("Safari");
    bnFirefox.setActionCommand("Firefox");
    bnOpera.setActionCommand("Opera");
    bnChrome.setActionCommand("Chrome");
    bnBrowser5.setActionCommand("Browser5");
    
    bnSafari.setForeground(Color.red);
    bnFirefox.setForeground(Color.red);
    bnOpera.setForeground(Color.red);
    bnChrome.setForeground(Color.red);
    bnBrowser5.setForeground(Color.BLUE);
    
	chkRunTab0.setMargin(new Insets(5,50,5,5));
	chkRunTab0.addActionListener(this);
	chkRunTab0.setActionCommand("chkRunTab0");
	toolBar.add(chkRunTab0);
			
    
    
    setFontsize(fontsize);
        
    this.getContentPane().add(toolBar, BorderLayout.NORTH);
    
    if (isWindows) {
    	bnSafari.setEnabled(false);
    	bnSafari.setForeground(Color.GRAY);    	
    }
  } // setToolBars


 
  public void actionPerformed(ActionEvent e) {
       String cmd = e.getActionCommand();
       if (cmd.equals("NewFile") ) {
           mnNew_Click();
        }
       if (cmd.equals("OpenFile") ) {
          mnOpen_Click();
       }
       if (cmd.equals("SaveFile") ) {
          mnSave_Click();
       }
       if (cmd.equals("SaveAsFile") ) {
          mnSaveAs_Click();
       }
       if (cmd.equals("SaveAllFiles") ) {
          mnSaveAllFiles_Click();
       }
       
       if (cmd.equals("SaveAllFiles") ) {
          mnSaveAllFiles_Click();
       }

       if (cmd.equals("Calc") ) {
          try {
            ProcessBuilder proc = new ProcessBuilder("calc.exe");
            proc.start();
          }
          catch (IOException e1) {
          }
       }
       if (cmd.equals("Dos") ) {
          try {
        	  if (isWindows) {
                  ProcessBuilder proc = new ProcessBuilder("cmd.exe");
                  proc.start();
        	  }
        	  else {
                  ProcessBuilder proc = new ProcessBuilder("bash");
                  proc.start();
        	  }
          }
          catch (IOException e1) {
          }
       }
       if (cmd.equals("Notepad") ) {
          mnNotepad_Click();
       }

       if (cmd.equals("Explorer") ) {
          try {
            ProcessBuilder proc = new ProcessBuilder("explorer.exe");
            proc.start();
          }
          catch (IOException e1) {
          }
       }
       
       //----------------------------------
       if (cmd.equals("Cut") ) {
          mnCut_Click();
       }
       if (cmd.equals("Copy") ) {
          mnCopy_Click();
       }
       if (cmd.equals("Paste") ) {
          mnPaste_Click();
       }
       if (cmd.equals("SelectAll") ) {
          mnSelectAll_Click();
       }
   
       
       if (cmd.equals("StandardBrowser") ) {
          execute("", true);
       }
       if (cmd.equals("Safari") ) {
    	   Safari_Click();
        }
       if (cmd.equals("Firefox") ) {
           Firefox_Click();
        }
       if (cmd.equals("Opera") ) {
          Opera_Click();
       }
       if (cmd.equals("Chrome") ) {
          Chrome_Click();
       }
       if (cmd.equals("Browser5") ) {
          Browser5_Click();
       }
       if (cmd.equals("Browser6") ) {
          Browser6_Click();
       }
       
       //---------------------------------
       

       if (cmd.equals("Cascade") ) {
          mnCascade_Click();
       }
       if (cmd.equals("Tile") ) {
          mnTile_Click();
       }
       
       if (cmd.equals("TileVertical") ) {
          mnTileVertical_Click();
       }
       if (cmd.equals("TileHorizontal") ) {
          mnTileHorizontal_Click();
       }
       
       
       if (cmd.equals("Windows") ) {
            try {
                UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
                SwingUtilities.updateComponentTreeUI(this.getContentPane() );  // alles neuzeichnen
                return;
            }
            catch (Exception elook) {
            }
       }
       if (cmd.equals("Motif") ) {
            try {
                UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
                SwingUtilities.updateComponentTreeUI(this.getContentPane() );  // alles neuzeichnen
                return;
            }
            catch (Exception elook) {
            }
       }
       if (cmd.equals("Metal") ) {
            try {
                UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
                SwingUtilities.updateComponentTreeUI(this.getContentPane() );  // alles neuzeichnen
                return;
            }
            catch (Exception elook) {
            }
       }
       if (cmd.equals("Nimbus") ) {
            try {
                UIManager.setLookAndFeel("com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel");
                SwingUtilities.updateComponentTreeUI(this.getContentPane() );  // alles neuzeichnen
                return;
            }
            catch (Exception elook) {
            }
       }
       
       if (cmd.equals("showOptions") ) {
        showOptions();
       }
       
       if (cmd.equals("ProgInfo") ) {
        showProgInfo();
       }
       
       if (cmd.equals("fontsize") ) {
           setFontsize( (MyJCheckBoxMenuItem)e.getSource());
          }
       
       
    }  // actionPerformed

  private void setFontsize(MyJCheckBoxMenuItem mn) {
	  this.fontsize = mn.tag;
	  Basis.setMenueFont( menuBar1, true, this.fontsize);
	  setFontsize(this.fontsize);
	  singvar.writeProperties();

  }
  
  private void setFontsize(int fontsize) {
	  singvar.setFontsize(this.fontsize);
      for (int j=0; j<mainFont.getItemCount(); j++) {
          // Abfrage auf Separator, sonst Absturz
          if ( mainFont.getItem(j) instanceof MyJCheckBoxMenuItem ) {
        	  MyJCheckBoxMenuItem mn2 =(MyJCheckBoxMenuItem) mainFont.getItem(j);  
        	  if (mn2.tag==this.fontsize) {
        		  mn2.setSelected(true);
        	  }
        	  else {
        		  mn2.setSelected(false);
        	  }
          }
        }
      // Clientfenster
      for (JInternalFrame frame : _desktopPane.getAllFrames())     {
          ChildForm child2 = ((ChildForm)frame);
          child2.setFontSize(this.fontsize);
      }  // foreach (TabPage page in tabControl1.TabPages)
      
      
	  bnOpen.setFont( new Font("Arial", Font.BOLD,fontsize)  );
	    bnNew.setFont( new Font("Arial", Font.BOLD,fontsize)  );
	    bnSave.setFont( new Font("Arial", Font.BOLD,fontsize)  );
	    bnSaveAll.setFont( new Font("Arial", Font.BOLD,fontsize)  );
	    
	    bnSafari.setFont( new Font("Arial", Font.BOLD,fontsize)  );
	    bnFirefox.setFont( new Font("Arial", Font.BOLD,fontsize)  );
	    bnOpera.setFont( new Font("Arial", Font.BOLD,fontsize)  );
	    bnChrome.setFont( new Font("Arial", Font.BOLD,fontsize)  );
	    bnBrowser5.setFont( new Font("Arial", Font.BOLD,fontsize)  );
	    chkRunTab0.setFont(new Font("Arial", Font.BOLD, fontsize));
	}
  
  private void execute(ChildForm child, String sBrowser, boolean bStandard) {
	  String filename="";
      if (!child.getFilename().equals(SingVar.C_NONAME)) {
          child.saveFile();
          filename=child.getFilename();
          String ext = Basis.getFileExt(filename).toLowerCase();
          //System.out.println("ext: "+ext);
          if (ext.equals(".css")) {
              // suche html-child
              String filenameXhtml = Basis.changeFileExt(filename, ".xhtml");
              
              for (JInternalFrame frame : _desktopPane.getAllFrames())     {
                  ChildForm child2 = ((ChildForm)frame);
                  if (child2.getFilename().equals(filename)) {
                      child2.saveFile();
                      filename=filenameXhtml;
                      break;
                  }
              }  // foreach (TabPage page in tabControl1.TabPages)                  
          }
          String param = filename;
          if (ext.equals(".php") || ext.equals(".xhtml") || ext.equals(".htm") || ext.equals(".html") || ext.equals(".jsp")) {
            int posi = filename.indexOf("htdocs\\");
            // System.out.println("posi: "+posi);
            if (posi>=0) {
            	if (sBrowser.toLowerCase().indexOf("firefox.exe")>=0) 
                    param = "localhost:"+ singvar.getPhpPort()+"/" + filename.substring(posi + 7).replace("\\", "/");
                else
                    param = "127.0.0.1:" + singvar.getPhpPort() + "/" + filename.substring(posi + 7).replace("\\", "/");
            	System.out.println("param: "+param);
            }  
          }
          
          
          ProcessBuilder proc;
          try {
        	  if (isWindows) {
                  if (bStandard) {
                      proc = new ProcessBuilder("\"" +param+"\"", ""  );
                      proc.start();
                  }
                  else    {
                    proc = new ProcessBuilder(  sBrowser , "\"" +param+"\""  );
                    proc.start();
                  }              
        	  }
        	  else {
        		  // apple linux
        		  if (chkRunTab0.isSelected()) {
        			  int posi = filename.indexOf("htdocs/");
        			  param = "localhost/"+ filename.substring(posi + 7);

        			  StringSelection selection = new StringSelection(param);
        			  Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
        			  clipboard.setContents(selection, selection);
        			  
        			  /*
lipboardContent content = new ClipboardContent();
content.putString("Some text");
content.putHtml("<b>Bold</b> text");
Clipboard.getSystemClipboard().setContent(content);
        			  */
                      Process process = Runtime.getRuntime().exec(param);
                      process = Runtime.getRuntime().exec(sBrowser+" " +param); 
        		  }
        		  else {
                      Process process = Runtime.getRuntime().exec("open " +param); 
        		  }
        	  }
          }
          catch (IOException e1) {
        	  Basis.ErrorBox(e1.toString(),"Error to call the browser\n"+sBrowser);
          }  
      }  // if (!child.getFilename().equals(SingVar.C_NONAME)) {
	  
  }  // execute
  
   private void execute(String sBrowser, boolean bStandard) {     
	//   System.out.println(sBrowser);
        
        ChildForm child = getActiceForm();
        if (child != null) {
        	execute(child, sBrowser, bStandard);          
        }  // child != null  
            
   }  // execute
   
   private void Safari_Click() {
//	   String sBrowser =    singvar.getSafari();
//	   if (sBrowser.length()==0) {
//		   Basis.MessageBox("Der Safari-Browser ist nicht gesetzt","Hinweis");		   
//	   }
//	   else {
	   if (singvar.getSafari().length()>0)
		   execute(singvar.getSafari(),false);
	   else
		   execute("",false);
//	   }
   }
   
   private void Firefox_Click() {
	   	if (isWindows) {
		      String sBrowser =    singvar.getFirefox();
		      if (sBrowser.length()==0) {
				   Basis.MessageBox("Der Firefox-Browser ist nicht gesetzt","Hinweis");		   
			   }
			   else {
				   execute(sBrowser,false);
			   }
	   	}
	   	else {
			   execute("",false);
	   }
   }
   
   private void Opera_Click() {
	   if (isWindows) {
	   String sBrowser =    singvar.getOpera();
	   if (sBrowser.length()==0) {
		   Basis.MessageBox("Der Opera-Browser ist nicht gesetzt","Hinweis");		   
	   }
	   else {
		   execute(sBrowser,false);
	   }
	   }
	   else {
		   execute("",false);
	   }
   }

   private void Chrome_Click() {
	   if (isWindows) {
		   String sBrowser =    singvar.getChrome();   
		   if (sBrowser.length()==0) {
			   Basis.MessageBox("Der Chrome-Browser ist nicht gesetzt","Hinweis");		   
		   }
		   else {
			   execute(sBrowser,false);
		   }
	   }
	   else {
		   execute("",false);
	   }
   }
   
 
   private void Browser5_Click() {
      SingVar singvar = SingVar.getInstance();
      if (Basis.FileExists(singvar.getBroswer5()) )
          execute(singvar.getBroswer5(), false);
      else
          Basis.MessageBox("Der 5. Browser ist nicht vorhanden", "Hinweis");
   }
   
   private void Browser6_Click() {
      SingVar singvar = SingVar.getInstance();
      
      if (Basis.FileExists(singvar.getBroswer6()) )
          execute(singvar.getBroswer6(), false);
      else
          Basis.MessageBox("Der 6. Browser ist nicht vorhanden", "Hinweis");
   }
  
 private void addClientFrame(JInternalFrame frame) {
     final int w = 550;
     final int h = 400;
     int pos = _desktopPane.getAllFrames().length+1;
     frame.setBounds(
             (pos*50 % (_desktopPane.getWidth()-w) ),
             (pos*50 % (_desktopPane.getHeight()-h) ),
             w, h);
     _desktopPane.add(frame);
     _desktopPane.moveToFront(frame);
     
  }



     // Beispiel zum Oeffnen EINER Datei
  private void mnNew_Click() {
    FRadio3 frame = new FRadio3(this);
    if (frame.bResult) {      
      String filename = SaveNewFile(frame.iNeuerDateiTyp);
      if (filename.equals("")) return;
      String   filenameCSS = Basis.changeFileExt(filename, "css");

      switch (frame.iNeuerDateiTyp)  {
          case FRadio3.C_HTMLCSS:                                
                              SingVar.SaveCSS_Html_BasicXHTML(filename, filenameCSS);
                              HTMLForm childForm1a = new HTMLForm(filename); // SingVar.C_NONAME);
                              addClientFrame(childForm1a);
                              
                              CSSForm childForm1b = new CSSForm(filenameCSS);
                              addClientFrame(childForm1b);
                              mnTileVertical_Click();
                              break;

          case FRadio3.C_PHPHTML:
        	  				SingVar.SaveCSS_Html_BasicPhpCSS(filename, filenameCSS);

        	  				 HTMLForm childForm2a = new HTMLForm(filename); // SingVar.C_NONAME);
                              addClientFrame(childForm2a);
                              
                              CSSForm childForm2b = new CSSForm(filenameCSS);
                              addClientFrame(childForm2b);
                              mnTileVertical_Click();
                              
                              break;
                              
          case FRadio3.C_PHPPUR: 
        	  					HTMLForm childForm3 = new HTMLForm(filename); // SingVar.C_NONAME);
        	  					addClientFrame(childForm3);
        	  					break;

          case FRadio3.C_JAVASCRIPT:
				              SingVar.SaveJavascript(filename);
				              HTMLForm childFormJs = new HTMLForm(filename); // SingVar.C_NONAME);
				              addClientFrame(childFormJs);
                              break;
          default:            Basis.MessageBox("Fehler in Modul NewClick, Falsche Dateiauswahl","Hinweis");
                              break;
      }
    }  
  }  // mnNew

  
    private String SaveNewFile(int filetyp) {      
      String DefaultExt="";
      JFileChooser jfc;
      jfc = new JFileChooser();
      jfc.setMultiSelectionEnabled(false);
      jfc.setCurrentDirectory(  new File(  (String) System.getProperties().get("user.dir")  )   );
      jfc.setCurrentDirectory(  new File(  "D:\\cdaten\\html"  )   );
  
      switch (filetyp)  {
            case FRadio3.C_HTMLCSS:
                    jfc.addChoosableFileFilter(  new MyFileFilter( "xhtml", "HTML-Dateien (*.xhtml)")  );
                    jfc.addChoosableFileFilter(  new MyFileFilter( new String[] {"html", "htm"}, "HTML-Dateien (*.html;*.htm)")  );
                    jfc.addChoosableFileFilter(  new MyFileFilter( new String[] {"xhtml","html", "htm"}, "HTML-Dateien (*.xhtml;*.html;*.htm)")  );
                    jfc.addChoosableFileFilter(  new MyFileFilter( "css", "CSS-Dateien (*.css)")  );
                    jfc.addChoosableFileFilter(  new MyFileFilter( "php", "PHP-Dateien (*.php)")  );
                    DefaultExt = ".xhtml";
                    break;

            case FRadio3.C_PHPHTML:
            case FRadio3.C_PHPPUR:
                jfc.addChoosableFileFilter(  new MyFileFilter( "php", "PHP-Dateien (*.php)")  );
                jfc.addChoosableFileFilter(  new MyFileFilter( "xhtml", "HTML-Dateien (*.xhtml)")  );
                jfc.addChoosableFileFilter(  new MyFileFilter( new String[] {"html", "htm"}, "HTML-Dateien (*.html;*.htm)")  );
                jfc.addChoosableFileFilter(  new MyFileFilter( new String[] {"xhtml","html", "htm"}, "HTML-Dateien (*.xhtml;*.html;*.htm)")  );
                jfc.addChoosableFileFilter(  new MyFileFilter( "css", "CSS-Dateien (*.css)")  );
                DefaultExt = ".php";
                break;

            case FRadio3.C_JAVASCRIPT:
                    jfc.addChoosableFileFilter(  new MyFileFilter( "js", "Js-Dateien (*js)")  );
                    DefaultExt = ".js";
                    break;
              
            default: Basis.MessageBox("Fehler in Modul SaveNewFile, Falscher Dateityp","Hinweis");
                break;
        }

        if (JFileChooser.APPROVE_OPTION == jfc.showSaveDialog(this)) {
            String sFilename = jfc.getSelectedFile().getPath();
            if (sFilename.indexOf(".")==-1) {
              sFilename += DefaultExt;
            }
            
            return sFilename;
        }
        else
            return "";
    }


  private void mnOpen_Click() {
   JFileChooser jFileChooser1;
   File [] files;  // Array fr

   jFileChooser1 = new JFileChooser();
   jFileChooser1.setMultiSelectionEnabled(true);

   String path = singvar.getStartDir();
   jFileChooser1.setCurrentDirectory(  new File(  (String) System.getProperties().get("user.dir")  )   );
   jFileChooser1.setCurrentDirectory(  new File(  path  )   );

   jFileChooser1.addChoosableFileFilter(  new MyFileFilter( "xhtml", "HTML-files (*.xhtml)")  );
   
   jFileChooser1.addChoosableFileFilter(  new MyFileFilter( new String[] {"html", "htm"}, "HTML-Dateien (*.html;*.htm)")  );
   jFileChooser1.addChoosableFileFilter(  new MyFileFilter( new String[] {"xhtml","html", "htm"}, "HTML-Dateien (*.xhtml;*.html;*.htm)")  );
   jFileChooser1.addChoosableFileFilter(  new MyFileFilter( "css", "CSS-files (*.css)")  );

   jFileChooser1.addChoosableFileFilter(  new MyFileFilter( new String[] {"xml","xsl"}, "XML-Dateien (*.xml;*.xsl)")  );

   jFileChooser1.addChoosableFileFilter(  new MyFileFilter( "php", "PHP-files (*.php)")  );
   jFileChooser1.addChoosableFileFilter(  new MyFileFilter( "*", "All files (*.*)|*.*")  );
 
   jFileChooser1.setPreferredSize(new Dimension(1000,600));
   jFileChooser1.setDialogTitle("Open file(s)");
     // Okay gedrckt ?
    if (JFileChooser.APPROVE_OPTION == jFileChooser1.showOpenDialog(this)) {
      files = jFileChooser1.getSelectedFiles();
      for (int i=0; i<files.length; i++) {
        checkFileopen( files[i].getPath() );
      }
    }
  }  // mnOpen


  private void checkFileopen( String sFilename ) {
    JInternalFrame[] ff = _desktopPane.getAllFrames();
    
    boolean bIsOpen = false;
    for (JInternalFrame childForm: ff) {     
       String s = ((ChildForm)childForm).getFilename();
       if (sFilename.equals(s) ) {
           _desktopPane.setSelectedFrame(childForm);
           bIsOpen = true;
           break;
       }
    }
    if (!bIsOpen) {
      OpenFile(sFilename);
      //SingVar instance = SingVar.getInstance();
      //instance.deleteFile(sFilename);
    }
  }
  
  private void OpenFile(String filename) {
    String sExt = Basis.getFileExt(filename).toLowerCase();
    try {
        singvar.setStartDir(Basis.getPath(filename));
        //System.out.println("**************** openPath: "+Basis.getPath(filename));
    }
    catch (Exception e) {
    	System.out.println("exception "+e.toString());
    }    
    singvar.writeProperties();
            // getFilenameExt(sFilename).ToLower();
    if (sExt.equals(".css") ) {
       CSSForm frame = new CSSForm( filename );
       addClientFrame(frame); 
    }
    else {
       HTMLForm frame = new HTMLForm( filename );
       addClientFrame(frame);    
   }
  }
  
  private ChildForm getActiceForm() {
   JInternalFrame[] ff = _desktopPane.getAllFrames();
   if (ff.length>0) 
     return (ChildForm) ff[0]; 
   else
     return null;
  }
  
  private void  mnNotepad_Click() {
    String sFilename="";
    ChildForm child = getActiceForm();
    if (child != null) {
      if (!child.getFilename().equals(SingVar.C_NONAME)) {
          sFilename=child.getFilename();
      }
    }    
    try {
      ProcessBuilder proc = new ProcessBuilder("notepad.exe", "\"" +sFilename+"\""  );
      proc.start();
    }
    catch (IOException e1) {
    }    
  }  // MnNotepad_Click

  
  private void  mnSaveAllFiles_Click() {
   JInternalFrame[] ff = _desktopPane.getAllFrames();
   for (JInternalFrame frame:ff) {
     ChildForm child = (ChildForm) frame;
     if (child.getFilename().equals(SingVar.C_NONAME))
          mnSaveAs_Click();
     else
       child.saveFile();
   }
  }
  
  private void mnSave_Click() {
    ChildForm child = getActiceForm();
    if (child != null) {
      if (child.getFilename().equals(SingVar.C_NONAME))
           mnSaveAs_Click();
      else
        child.saveFile();
    }    
  }

  private void mnSaveAs_Click() {
   JFileChooser jFileChooser1;
   ChildForm child = getActiceForm();
   if (child != null) {
	   String filenameOri = child.getFilename();
	   String extOri = Basis.getFileExt(child.getFilename()).toLowerCase();
      jFileChooser1 = new JFileChooser();
      jFileChooser1.setMultiSelectionEnabled(false);
      jFileChooser1.setCurrentDirectory(  new File(  (String) System.getProperties().get("user.dir")  )   );
      jFileChooser1.setCurrentDirectory(  new File(  "D:\\cdaten\\html"  )   );
      jFileChooser1.addChoosableFileFilter(  new MyFileFilter( "xhtml", "HTML-Dateien (*.xhtml)")  );
      jFileChooser1.addChoosableFileFilter(  new MyFileFilter( new String[] {"html", "htm"}, "HTML-Dateien (*.html;*.htm)")  );
      jFileChooser1.addChoosableFileFilter(  new MyFileFilter( new String[] {"xhtml","html", "htm"}, "HTML-Dateien (*.xhtml;*.html;*.htm)")  );
      jFileChooser1.addChoosableFileFilter(  new MyFileFilter( "css", "CSS-Dateien (*.css)")  );
      jFileChooser1.addChoosableFileFilter(  new MyFileFilter( new String[] {"xml","xsl"}, "XML-Dateien (*.xml;*.xsl)")  );
      jFileChooser1.addChoosableFileFilter(  new MyFileFilter( "php", "PHP-Dateien (*.php)")  );
      jFileChooser1.addChoosableFileFilter(  new MyFileFilter( "*", "Alle Dateien (*.*)|*.*")  );
      jFileChooser1.setPreferredSize(new Dimension(1000,600));
      jFileChooser1.setDialogTitle("Datei speichern");
      // Okay gedrckt ?
      if (JFileChooser.APPROVE_OPTION == jFileChooser1.showSaveDialog(this)) {
        String filenameNew = jFileChooser1.getSelectedFile().getPath();
        String extNew = Basis.getFileExt(filenameNew).toLowerCase();
        if (extNew.length()==0) {
        	filenameNew+=extOri;
        }
        child.saveAs(filenameNew);
        // suche test1.css
        String filenameCssOri = Basis.changeFileExt(filenameOri, "css");
        String filenameCssNew = Basis.changeFileExt(filenameNew, "css");
        System.out.println("cssOri:"+filenameCssOri);
        System.out.println("cssnew:"+filenameCssNew);
        boolean gefunden=false;
        for (JInternalFrame frame : _desktopPane.getAllFrames())     {
            ChildForm child2 = ((ChildForm)frame);
            if (child2.getFilename().equals(filenameCssOri)) {
            	System.out.println("   -:"+child2.getFilename());
            	 child2.saveAs(filenameCssNew);
            	 gefunden=true;
            }
        }  // foreach (TabPage page in tabControl1.TabPages)
        
        if (!gefunden && Basis.FileExists(filenameCssOri) ) {
        	Basis.filecopy(filenameCssOri, filenameCssNew);
        }
        
      }
    
    }
    
  }  // mnSaveAs
  
  private void mnCut_Click() {
    ChildForm child = getActiceForm();
    if (child != null) {
        child.cut();
    }    
  }
  
  private void mnCopy_Click() {
    ChildForm child = getActiceForm();
    if (child != null) {
        child.copy();
    }    
  }
  
  private void mnPaste_Click() {
    ChildForm child = getActiceForm();
    if (child != null) {
        child.paste();
    }    
  }
  
  private void mnSelectAll_Click() {
    ChildForm child = getActiceForm();
    if (child != null) {
        child.selectAll();
    }    
  }
   
     

   // wird aufgerufen beim Schliessen des Hauptfensters
  private void mnClose_Click() {
     this.dispose(); //     System.exit(0);
  }


   // -----------------
  private void setCascadeFrame() {
   final int w = 250;
   final int h = 150;
   JInternalFrame frame;     // the actual Clientwindow
   JInternalFrame[] ff;  // Array of all internal Clientwindow
   ff = _desktopPane.getAllFrames();
   for (int pos = 0; pos<ff.length; pos++) {
      frame = (JInternalFrame)ff[pos];  // typecasting
      frame.setBounds(
     (pos*50 % (_desktopPane.getWidth()-w) ),
     (pos*50 % (_desktopPane.getHeight()-h) ), 
         w, h);
   } // for
  }  // setCascadeFrame()


   // -----------------
   // Cascade der Fenster
  private void mnCascade_Click() {
      int i, j, p, Abstand, w, h, n;
      JInternalFrame f;     // the actual Clientwindow
      JInternalFrame[] ff;  // Array of all internal Clientwindow
      ff = _desktopPane.getAllFrames();
      n = ff.length;  // Count of Frames
      // calc the distance of the frames, depends on the count of the frames
      if (n > 0) {
           if (n<=3)
             Abstand = 80;
           else {
             if (n>6)
               Abstand = 25;
             else
               Abstand = 40;
           }
           // calc the width and height of each frame
           w = _desktopPane.getWidth() - (n-1)*Abstand;
           h = _desktopPane.getHeight() - (n-1)*Abstand;
           if ( (w<80) || (h<80) || (n>20) ) {
              setCascadeFrame();
           }
           else {
             if (w<=0) w = 100;
             if (h<=0) h = 50;
             // the top frame has the index 0 !
             // index i is for the position
             // index j ist for the frames, the last is the top-frame !
             for (i = 0, j=n-1; i <n; i++,j--) {
                 f = (JInternalFrame)ff[j];  // typecasting
                 p = i*Abstand;
                 f.setLocation(p, p);        // position
                 f.setSize(w,h);             // width height
             }
           }
      }
  }   // mnCascade_click() {

  private void mnTileVertical_Click() {
      JInternalFrame[] ff;    // Array for all internal frames
      JInternalFrame f; //
      int hoehe, breite, left, top;
      int i, n;
      ff = _desktopPane.getAllFrames();
        // Count > 0 ?
      if (ff.length > 0) {
          n = ff.length;
          breite = _desktopPane.getWidth() / n;
          hoehe = _desktopPane.getHeight()-10;
      //    hoehe = getHeight();
          if (ff.length==1 ) {
              f = (JInternalFrame)ff[0];
              try {
                  f.setMaximum(false);
                  f.setSize(_desktopPane.getWidth(), hoehe);
                  f.setLocation(0,0);
                  return;
              }
              catch (Exception e2) {
                  e2.printStackTrace();
              }            
          }
          left=0;
          for (i = ff.length - 1; i >= 0; i--) {
              f = (JInternalFrame)ff[i];
              //f.setSize(100,100);
              try {
                  f.setMaximum(false);
                  f.setSize(breite, hoehe);
                  f.setLocation(left,0);  // x/y
                  left+=breite;
              }
              catch (Exception e2) {
                  e2.printStackTrace();
              }
          }
      }
    
  }


  private void mnTileHorizontal_Click() {
      JInternalFrame[] ff;    // Array for all internal frames
      JInternalFrame f; //
      int hoehe, breite, top;
      int i, n;
      ff = _desktopPane.getAllFrames();
        // Count > 0 ?
      if (ff.length > 0) {
          n = ff.length;
          breite = _desktopPane.getWidth() ;
          hoehe = _desktopPane.getHeight()/ n;
          if (ff.length==1 ) {
              f = (JInternalFrame)ff[0];
              try {
                  f.setMaximum(false);
                  f.setSize(_desktopPane.getWidth(), hoehe);
                  f.setLocation(0,0);
                  return;
              }
              catch (Exception e2) {
                  e2.printStackTrace();
              }            
          }
          top=0;
          for (i = ff.length - 1; i >= 0; i--) {
              f = (JInternalFrame)ff[i];
              //f.setSize(100,100);
              try {
                  f.setMaximum(false);
                  f.setSize(breite, hoehe);
                  f.setLocation(0,top);  // x/y
                  top+=hoehe;
              }
              catch (Exception e2) {
                  e2.printStackTrace();
              }
          }
      }
    
  }



   // Aufteilen der Fenster
  void mnTile_Click() {
      JInternalFrame[] ff;    // Array for all internal frames
      JInternalFrame f; //
      int hoehe, anz, breite, left, top;
      int indexCol, anzCol, anzRow, anzRowUnten, n, i, h, b1, b2;
      boolean bZweiBreiten;

      ff = _desktopPane.getAllFrames();
        // Count > 0 ?
      if (ff.length > 0) {
          // Quadratische Aufteilung

            /*
             5:
                 -
                - -
                - -

             11:
                 - -
                - - -
                - - -
                - - -

            */

          n = ff.length;
          if (n < 1) {
              return;
          }
          if (n == 1) {
              f = (JInternalFrame)ff[0];
              try {
                  f.setMaximum(true);
              }
              catch (Exception e1) {
                  e1.printStackTrace();
              }
              return;
          }

          anzCol = (int)Math.round(Math.sqrt(n)); // Wurzel aus Anzahl
          // bestimme Anzahl der unteren (vollen) Zeilen
          anzRowUnten = n / anzCol;  // trunc
            // Abfrage nach Rest
          if (n > (anzRowUnten * anzCol)) {
              anzRow = anzRowUnten + 1;
              bZweiBreiten = true;
          }
          else {
              anzRow = anzRowUnten;
              bZweiBreiten = false;
          }
          //  AnzRow zeigt die Anzahl aller Zeilen

          // nun werden zwei Breiten und eine Hhe ausgerechnet
          // 1. Breite  gilt fuer die vollen Reihen
          // 2. Breite  gilt fuer oberste  Reihe, falls sie nicht voll ist
          hoehe = _desktopPane.getHeight();
          h = _desktopPane.getHeight() / anzRow;
          b1 = _desktopPane.getWidth() / anzCol; // volle Breite
          if (bZweiBreiten)
             b2 = _desktopPane.getWidth() / (n - anzCol * anzRowUnten); // untere Breite
          else
             b2 = b1;

          // Rueckwaerts
          anz = 0;
          left = 0;
          top = hoehe - h;
          indexCol = 0;
          for (i = ff.length - 1; i >= 0; i--) {
              f = (JInternalFrame)ff[i];
              //f.setSize(100,100);
              try {
                  f.setMaximum(false);
              }
              catch (Exception e2) {
                  e2.printStackTrace();
              }
              anz++;
              indexCol++;
              if (indexCol > anzCol) {
                  // neue Reihe anfangen
                  left = 0;
                  top -= h;
                  indexCol = 1;
              }
              // Position im Fenster setzen
              f.setLocation(left, top);
              // Breite Hhe setzen
              // Check, ob man in der obersten Zeile sich befindet ?
              if (anz > (anzRowUnten * anzCol)) {
                  f.setSize(b2, h); // width height
                  left += b2;
              }
              else {
                  f.setSize(b1, h); // width height
                  left += b1;
              }
          }
      }
  }  // Tile

  
  private void  showOptions() {
    ChildForm child;
    FShowOptions form = new FShowOptions(this);
    if (form.bResult) {
      // alle Eigenschaften neu setzen, in allen Clients
      for (JInternalFrame frame : _desktopPane.getAllFrames() ) {
        child = (ChildForm) frame;
        child.updateOptionSession();
      }      
    }
  }  // showOptions
  

  private void  showProgInfo() {    
    FProgInfo form = new FProgInfo(this);
  }  // showOptions
  
  public void bnHelpWindows_click() {
	  String paths = "C:\\Program Files\\Mozilla Firefox\\firefox.exe\r\n" + 
	  		"C:\\Program Files (x86)\\Mozilla Firefox\\firefox.exe\r\n" + 
	  		"C:\\Users\\User1\\AppData\\Local\\Programs\\Mozilla Firefox\\firefox.exe\r\n" + 
	  		"\r\n" + 
	  		"C:\\Program Files (x86)\\Opera\\Application\\chrome.exe\r\n" + 
	  		"C:\\Program Files\\Opera\\Application\\chrome.exe\r\n" + 
	  		"C:\\Program Files (x86)\\Opera\\chrome.exe\r\n" + 
	  		"C:\\Program Files\\Opera\\chrome.exe\r\n" + 
	  		"C:\\Users\\User1\\AppData\\Local\\Programs\\Opera\\66.0.3515.72\\opera.exe\r\n" + 
	  		"\r\n" + 
	  		"C:\\Program Files (x86)\\Google\\Chrome\\Application\\chrome.exe\r\n" + 
	  		"C:\\Program Files\\Google\\Chrome\\Application\\chrome.exe";
  
  }  
   // Hauptprogramm
  static public void main(String[] args) {
    IHTML frame = new IHTML();
    frame.setVisible(true);
  }

 
}
