﻿import java.awt.*;
import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.StringSelection;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;  // modify
import javax.swing.undo.UndoManager;

//import SplitColorTextPane.ColorString;

//import SplitColorTextPane.StringList;

//import Frame.MyDocumentListener;
//import Frame.MyUndoableEditListener;

//import .CaretListenerLabel;

import java.io.*;
import java.util.ArrayList;
import java.util.HashMap;



import javax.swing.text.*;
import javax.swing.undo.*;
import javax.swing.event.*;

import java.awt.datatransfer.*; 

public class ChildForm  extends JInternalFrame {
  
  private String filename=SingVar.C_NONAME;
  private String _Caption="";
  
  private boolean _bModify=false;
  
  private JScrollPane paneLeft = null;
  private JScrollPane paneRight = null;
  
  protected JTextArea _lineeditor = new JTextArea();
  protected JTextPane _editor = new JTextPane();
  
  protected SplitColorTextPane splitColorTextPane = new SplitColorTextPane();
  private Color colorHTML = Color.BLUE;
  private Color colorNormalText = Color.BLACK;
  private Color colorSpecialChars = Color.RED;
  private Color colorComment = new Color(185,122,87);
  private Color colorLightBlue = new Color(100,100,255);
  private Color colorLinenumber = new Color(100,100,255);
  private Color colorBackground = Color.WHITE;  
  
  // RTF
  private StyledDocument styledDoc = null;
  private	AbstractDocument doc = null;
	
  private	HashMap<Object, Action> actions;
   
  //undo helpers
  protected UndoManager undo = new UndoManager();
  protected CaretListenerLabel caretListenerLabel = new CaretListenerLabel(_editor, "Caret Status");
  
  private int fontsize=20; 
  
  
  public JTextPane getEditor() {
    return _editor;
  }

  
  public String getFilename() {
    return filename;
  }
  
//  public ChildForm() {
//	  this("");
//    //this(SingVar.C_NONAME);
//    
//  }
  
  public ChildForm(String filename) {
	  
    this.filename = filename;
    if (this.filename.equals("") )
      _Caption = SingVar.C_NONAME;
    else
      _Caption = filename;
    
    SingVar singvar = SingVar.getInstance();
    this.fontsize = singvar.getFontsize();
    
    setGUI();
    setRTF2();

    _editor.setFont( new Font("Courier New", Font.PLAIN,fontsize) );
    
    _lineeditor.setLineWrap(false);
    _lineeditor.setFont( new Font("Courier New", Font.PLAIN,fontsize) );
    
    loadFile();
    _editor.setCaretPosition(0);
    _lineeditor.setCaretPosition(0);
    
    
    setDefaultCloseOperation( JFrame.DO_NOTHING_ON_CLOSE );
    
    setVisible(true);  
    // installLnF();
  }

  private void setRTF2() {
	  styledDoc = _editor.getStyledDocument();
		 if (styledDoc instanceof AbstractDocument) {
	            doc = (AbstractDocument)styledDoc;
	            //doc.setDocumentFilter(new DocumentSizeFilter(MAX_CHARACTERS));
	        } else {
	            System.err.println("Text pane's document isn't an AbstractDocument!");
	            System.exit(-1);
	        }		 
		 addStylesToDocument(styledDoc);
		 
		 StyleContext sc = StyleContext.getDefaultStyleContext();
		 int step=25;
		 TabSet tabs = new TabSet(new TabStop[] { new TabStop(step),new TabStop(step<<1),new TabStop(step+step<<1),
				 new TabStop(step<<2),new TabStop(step+step<<2) });
		 AttributeSet paraSet = sc.addAttribute(SimpleAttributeSet.EMPTY, StyleConstants.TabSet, tabs);
		 _editor.setParagraphAttributes(paraSet, true);
		 
		//Start watching for undoable edits and caret changes.
	        doc.addUndoableEditListener(new MyUndoableEditListener());
	        _editor.addCaretListener(caretListenerLabel);
	        doc.addDocumentListener(new MyDocumentListener());
  }
  
  
  // wird aufgerufen wird Clientfenster, abgeleitet
  private void setGUI() {
    setClosable(true);
    setIconifiable(true);
    setMaximizable(true);
    setResizable(true);
    setTitle( _Caption );

   setLayout( new BorderLayout() );
    
  
   JPanel panelEditoren = new JPanel();
   panelEditoren.setLayout(new GridBagLayout());
	 _editor.setMargin(new Insets(5,5,5,5));
   
   
   paneLeft = new JScrollPane(_lineeditor);
   panelEditoren.add(paneLeft,
           new GridBagConstraints(0, 0, 1, 1, 10.0, 100.0,
           GridBagConstraints.EAST, GridBagConstraints.BOTH,
           new Insets(0,5,0,0), 0, 0));
   
   _lineeditor.setForeground(Color.BLUE);
   _lineeditor.setBackground(new Color(230,230,230));
   
   paneRight = new JScrollPane(_editor);
   panelEditoren.add(paneRight,
           new GridBagConstraints(1, 0, 1, 1, 100.0, 100.0,
           GridBagConstraints.EAST, GridBagConstraints.BOTH,
           new Insets(0,0,0,5), 0, 0));
   
   StringBuilder sb = new StringBuilder();
   for (int i=1; i<200; i++) {
	   sb.append(Basis.IStr3(i));
	   sb.append(Konst.NL);
   }
   _lineeditor.setText(sb.toString());
   
   add( panelEditoren, BorderLayout.CENTER);
  
   add(caretListenerLabel, BorderLayout.SOUTH);
   
    this.addInternalFrameListener(new InternalFrameAdapter(){
              @Override
              public void internalFrameClosing(InternalFrameEvent e) {
                                    window_close();
              }
          });	  
   
   _editor.getDocument().addDocumentListener( new DocumentListener() {
            @Override
            public void insertUpdate(DocumentEvent e) {
               _bModify=true;
            }
            @Override
            public void removeUpdate(DocumentEvent e) {
              _bModify=true;
            }
            @Override
            public void changedUpdate(DocumentEvent e) {
                // _bModify=true;
            }
        }      
     );     
  }  // setGUI
  
  protected void addStylesToDocument(StyledDocument doc) {
      //Initialize some styles.
      Style def = StyleContext.getDefaultStyleContext().getStyle(StyleContext.DEFAULT_STYLE);

      Style regular = doc.addStyle("regular", def);
      StyleConstants.setFontFamily(def, "Courier New");
      StyleConstants.setFontSize(regular, fontsize);
      System.out.println("fontsize:"+fontsize);
      StyleConstants.setForeground(regular, colorNormalText );
      //StyleConstants.setBackground(regular, colorBackground);

      /*
      Style s = doc.addStyle("italic", regular);
      StyleConstants.setFontFamily(def, "Courier New");
      StyleConstants.setItalic(s, true);
*/
      Style s = doc.addStyle("html", def);
      StyleConstants.setFontFamily(def, "Courier New");
      StyleConstants.setBackground(s, colorBackground);
      StyleConstants.setForeground(s, colorHTML);
       StyleConstants.setFontSize(s, fontsize);      
      
      s = doc.addStyle("special", def);
      StyleConstants.setFontFamily(def, "Courier New");
      StyleConstants.setForeground(s, colorSpecialChars);
      StyleConstants.setBackground(s, colorBackground);
      StyleConstants.setBold(s, false);
      StyleConstants.setFontSize(s, fontsize);
      
      s = doc.addStyle("tab", def);
      StyleConstants.setFontFamily(def, "Courier New");
      StyleConstants.setForeground(s, new Color(0,127,0));
      StyleConstants.setBackground(s, colorBackground);
      //StyleConstants.setBold(s, true);
       StyleConstants.setFontSize(s, fontsize+1);  // tabtab
            

      s = doc.addStyle("comment", def);
      StyleConstants.setFontFamily(def, "Courier New");
      StyleConstants.setForeground(s, colorComment);
      StyleConstants.setBackground(s, colorBackground);
      StyleConstants.setBold(s, true);
       StyleConstants.setFontSize(s, fontsize);
      
   
  }	

  
//This one listens for edits that can be undone.
  protected class MyUndoableEditListener  implements UndoableEditListener {
      public void undoableEditHappened(UndoableEditEvent e) {
          //Remember the edit and update the menus.
          undo.addEdit(e.getEdit());
          //undoAction.updateUndoState();
          //redoAction.updateRedoState();
      }
  }

  //And this one listens for any changes to the document.
  protected class MyDocumentListener   implements DocumentListener {
      public void insertUpdate(DocumentEvent e) {
          displayEditInfo(e);
      }
      public void removeUpdate(DocumentEvent e) {
          displayEditInfo(e);
      }
      public void changedUpdate(DocumentEvent e) {
          displayEditInfo(e);
      }
      private void displayEditInfo(DocumentEvent e) {
          Document document = e.getDocument();
          int changeLength = e.getLength();
          /*
          changeLog.append(e.getType().toString() + ": " +
              changeLength + " character" +
              ((changeLength == 1) ? ". " : "s. ") +
              " Text length = " + document.getLength() +
              "." + "\n");
              */
      }
  }	
  
  
    private void window_close() {
            if (_bModify) {
                int retcode;
                retcode = Basis.YesNoEsc("Closing the document","Do yout want to save the changes?");
                        switch (retcode) {
                          case Basis.YES: saveFile();                                         
                                          //Basis.MessageBox("Datei gespeichert, Fenster wird geschlossen", "Meldung");
                                          break;
                          case Basis.NO: 
                        	  			//Basis.MessageBox("Datei nicht gespeichert, Fenster wird geschlossen", "Meldung");
                                          break;
                          case Basis.ESC: 
                        	  				//Basis.MessageBox("Abbruch!", "Meldung");
                                          return;
                }			
            }            
            dispose();
    }  // window_close
  
  
  private void loadFile() {
    FileInputStream fin;
    InputStreamReader iin;
    LineNumberReader din;
    if (!filename.equals(SingVar.C_NONAME))   {
      if (Basis.FileExists(filename))    {
        StringBuilder sb=new StringBuilder();
        int i=0;
        try {
          fin = new FileInputStream(filename);
          iin = new InputStreamReader(fin);
          din = new LineNumberReader(iin);
          while  ( din.ready()  ) {
            int b = fin.read();
            char ch = (char) b;
            sb.append(ch);
          }
          parseText(sb.toString());
        }
        catch (IOException e) {
              System.err.println("IOException: " + e);
        }
      }
      else {
    	  parseText("");
      }
    }
  }  // loadFile
  
  char[] charPair = Character.toChars(0x2192);
//and to String, containing the character we want


  
//  public class StringList {
//      public int anzTabs = 0;
//      public ArrayList<ColorString> colorstrings = new ArrayList<ColorString>();
//  }
//  public class StringList {
//      public int anzTabs = 0;
//      public ArrayList<ColorString> colorstrings = new ArrayList<ColorString>();
//  }
  // !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	public void parseText(String text) {
//		_editor.setText(text);
//		format();
		//text = _editor.getText();
		splitColorTextPane.splitText(text);
		ArrayList<SplitColorTextPane.StringList> gesamtliste = splitColorTextPane.gesamtliste;
		_editor.setText("");
		for (SplitColorTextPane.StringList split : gesamtliste) {
			try {
				System.out.println(split.anzTabs);
				switch(split.anzTabs) {
				case 0:
					break;
				case 1:
					styledDoc.insertString(styledDoc.getLength(), Konst.C_TAB, styledDoc.getStyle("tab"));
					break;
				case 2:
					styledDoc.insertString(styledDoc.getLength(), Konst.C_TAB+Konst.C_TAB, styledDoc.getStyle("tab"));
					break;
				case 3:
					styledDoc.insertString(styledDoc.getLength(),Konst.C_TAB+Konst.C_TAB+Konst.C_TAB, styledDoc.getStyle("tab"));
					break;
				case 4:
					styledDoc.insertString(styledDoc.getLength(), "        ", styledDoc.getStyle("tab"));
					break;
				case 5:
					styledDoc.insertString(styledDoc.getLength(), "          ", styledDoc.getStyle("tab"));
					break;
				case 6:
					styledDoc.insertString(styledDoc.getLength(), "            ", styledDoc.getStyle("tab"));
					break;
				case 7:
					styledDoc.insertString(styledDoc.getLength(), "              ", styledDoc.getStyle("tab"));
					break;
				case 8:
					styledDoc.insertString(styledDoc.getLength(), "                ", styledDoc.getStyle("regular"));
					break;
				case 9:
					styledDoc.insertString(styledDoc.getLength(), "\t\t\t\t\t\t\t\t\t", styledDoc.getStyle("regular"));
					break;
					default:
						styledDoc.insertString(styledDoc.getLength(), "\t\t\t\t\t\t\t\t\t", styledDoc.getStyle("regular"));
						break;
				}
				for (int j = 0; j < split.colorstrings.size(); j++) {
					SplitColorTextPane.ColorString item = split.colorstrings.get(j);
					//System.out.println(item.sb.toString());

					switch (item.colortyp) {
					case html:
						styledDoc.insertString(styledDoc.getLength(), item.sb.toString(), styledDoc.getStyle("html"));
						break;
					case text:
						styledDoc.insertString(styledDoc.getLength(), item.sb.toString(),
								styledDoc.getStyle("regular"));
						break;
					case space:
						styledDoc.insertString(styledDoc.getLength(), item.sb.toString(),
								styledDoc.getStyle("regular"));
						break;
					case specialchars:
						styledDoc.insertString(styledDoc.getLength(), item.sb.toString(),	styledDoc.getStyle("special"));
						break;
					case comments:
						styledDoc.insertString(styledDoc.getLength(), item.sb.toString(),
								styledDoc.getStyle("comment"));
						break;
					default:
						break;
					}

				} // for(int j=0; j<split.colorstrings.size(); j++) {
				styledDoc.insertString(styledDoc.getLength(), Konst.NL, styledDoc.getStyle("regular"));
			} catch (BadLocationException e) {
				System.err.println("Couldn't insert initial text into text pane.");
			}
		}
		// _editor.setText(text);
	}
	
	// ??????????????????????????
	// an aktueller Position
  public void insertZeile(String text) {
	  StringSelection selection = new StringSelection(text);
	  Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
	  clipboard.setContents(selection, selection);
	  _editor.paste();
	  format();
  }
  
  public String getText() {
	  return _editor.getText();
  }
  
  private String getTabs(int tablength) {
	  StringBuilder sb = new StringBuilder();
      for (int i = 0; i < tablength; i++) {
          //sErg += "\t";
    	  sb.append(Konst.C_TAB);
      }
      return sb.toString();
  }
  
  public void format() {
      // check ob es eine *.js datei ist
      if (filename.toLowerCase().endsWith(".js")) {
          formatJavaScriptFile();
          return;
      }
      if (filename.toLowerCase().endsWith(".css")) {
          formatCSSFile();  //formatJavaScriptFile(); 
          return;
      }

      String javascript1 = "<script";
      String javascript2 = "</script";
      String jsp1 = "<%";
      String jsp2 = "%>";
      String php1 = "<?php";
      String php2 = "?>";
      boolean javascript = false;
      boolean jsp = false;
      boolean php = false;

      boolean doctype = false;
      boolean html = false;
      StringBuilder output = new StringBuilder();  // schneller als ein String                
      int tab = 0;
      int i1, i2;
      String line;
      String[] lines = _editor.getText().replace(Konst.C_TAB, "\t").split(Konst.NL);
      for (int i = 0; i < lines.length; i++) {
          line = lines[i].replace(Konst.C_TAB, "  ").trim();
          if (line.length() == 0) {
              output.append(Konst.NL);
              continue;
          }


          if (javascript) {
              i1 = line.indexOf(javascript2);
              if (i1 >= 0) {
                  javascript = false;
                  tab--;  // nur wenn nicht in einer Zeile
                  output.append(getTabs(tab));
                  output.append(line.trim());
                  output.append(Konst.NL);
                  if (tab == 0) output.append(Konst.NL);
                  continue;
              }
              else {
                  String str = output.toString();
                  
                  boolean anzSpitzAuf = line.endsWith("{");
                  boolean anzSpitzZu = line.startsWith("}");

                  //  } else {
                  int indexSpitzAuf = line.indexOf('{');
                  int indexSpitzZu = line.indexOf('}');
                  int indexelse = line.indexOf("else");
                  if (indexSpitzAuf >= 0 && indexSpitzZu >= 0 && indexSpitzZu < indexelse && indexSpitzAuf > indexelse) {
                      line = line.replace('\t', ' ');
                      tab--;  // nur wenn nicht in einer Zeile
                      output.append(getTabs(tab));
                      output.append(line.trim());
                      output.append(Konst.NL);
                      if (tab == 0) output.append(Konst.NL);
                      tab++;
                  }
                  else {
                      if (anzSpitzZu) {
                          tab--;  // nur wenn nicht in einer Zeile
                          output.append(getTabs(tab));
                          output.append(line.trim());
                          output.append(Konst.NL);
                          if (tab == 0) output.append(Konst.NL);
                      }
                      else {
                          if (anzSpitzAuf) {
                              // tab++;
                              line = line.replace('\t', ' ');
                              output.append(getTabs(tab));
                              output.append(line.trim());
                              output.append(Konst.NL);
                              i1 = line.indexOf(javascript2);
                              tab++;
                          }
                          else {
                              line = line.replace('\t', ' ');
                              output.append(getTabs(tab));
                              output.append(line.trim());
                              output.append(Konst.NL);
                          }
                      }
                  }
                  continue;
              }
          }
          else {  // noch kein Javascript
              i1 = line.indexOf(javascript1);
              if (i1 >= 0) {
                  javascript = true;
                  line = line.replace('\t', ' ').trim();
                  output.append(getTabs(tab));
                  output.append(line.trim());
                  output.append(Konst.NL);
                  tab++;
                  i1 = line.indexOf(javascript2);
                  if (i1 > 0) {
                      // in einer Zeile:  Anfang und ende
                      javascript = false;
                      tab--;
                  }
                  continue;
              }
          }  // javascript

          if (php) {
              i1 = line.indexOf(php2);
              if (i1 >= 0) {
                  php = false;
                  tab--;  // nur wenn nicht in einer Zeile
                  output.append(getTabs(tab));
                  output.append(line.trim());
                  output.append(Konst.NL);
                  if (tab == 0) output.append(Konst.NL);
                  continue;
              }
              else {
                  String str = output.toString();
                  //  } else {
                  int indexSpitzAuf = line.indexOf('{');
                  int indexSpitzZu = line.indexOf('}');
                  int indexelse = line.indexOf("else");

                  if (indexSpitzAuf >= 0 && indexSpitzZu >= 0 && indexSpitzZu < indexelse && indexSpitzAuf > indexelse) {
                      line = line.replace('\t', ' ');
                      tab--;  // nur wenn nicht in einer Zeile
                      output.append(getTabs(tab));
                      output.append(line.trim());
                      output.append(Konst.NL);
                      if (tab == 0) output.append(Konst.NL);
                      tab++;
                  }
                  else {

                      if (indexSpitzZu >= 0) {
                          tab--;  // nur wenn nicht in einer Zeile
                          output.append(getTabs(tab));
                          output.append(line.trim());
                          if (tab == 0) output.append(Konst.NL);
                      }
                      else {
                          if (indexSpitzAuf >= 0) {
                              // tab++;
                              line = line.replace('\t', ' ');
                              output.append(getTabs(tab));
                              output.append(line.trim());
                              output.append(Konst.NL);
                              tab++;
                          }
                          else {
                              line = line.replace('\t', ' ');
                              output.append(getTabs(tab));
                              output.append(line.trim());
                              output.append(Konst.NL);
                              // tab--;
                          }
                      }
                  }
                  //output.appendLine(line);
                  continue;
              }
          }
          else {
              i1 = line.indexOf(php1);
              if (i1 >= 0) {
                  php = true;
                  tab = 1;
                  line = line.replace('\t', ' ').trim();
                  output.append(line);
                  continue;
              }
          }



          if (jsp) {
              i1 = line.indexOf(jsp2);
              if (i1 >= 0) {
                  jsp = false;
                  tab--;  // nur wenn nicht in einer Zeile
                  output.append(getTabs(tab));
                  output.append(line.trim());
                  output.append(Konst.NL);
                  if (tab == 0) output.append(Konst.NL);
                  continue;
              }
              else {
                  String str = output.toString();
                  boolean anzSpitzAuf = line.endsWith("{");
                  boolean anzSpitzZu = line.startsWith("}");
                  if (anzSpitzZu) {
                      tab--;  // nur wenn nicht in einer Zeile
                      output.append(getTabs(tab));
                      output.append(line.trim());
                      output.append(Konst.NL);
                      if (tab == 0) output.append(Konst.NL);
                  }
                  else {
                      if (anzSpitzAuf) {
                          // tab++;
                          line = line.replace('\t', ' ');
                          output.append(getTabs(tab));
                          output.append(line.trim());
                          output.append(Konst.NL);
                          i1 = line.indexOf(javascript2);
                          tab++;
                      }
                      else {
                          line = line.replace('\t', ' ');
                          output.append(getTabs(tab));
                          output.append(line.trim());
                          output.append(Konst.NL);
                      }
                  }
                  continue;
              }
          }
          else {  // noch kein Javascript
              i1 = line.indexOf(jsp1);
              if (i1 >= 0) {
                  jsp = true;
                  line = line.replace('\t', ' ').trim();
                  output.append(getTabs(tab));
                  output.append(line.trim());
                  output.append(Konst.NL);
                  tab++;
                  i1 = line.indexOf(jsp2);
                  if (i1 > 0) {
                      // in einer Zeile:  Anfang und ende
                      jsp = false;
                      tab--;
                  }
                  continue;
              }
          }  // jsp



          i1 = line.indexOf("<?");  // <?xml version="1.0" encoding="UTF-8" ?>
          i2 = line.toLowerCase().indexOf("<!doc");  // <!DOCTYPE html



          if (i1 >= 0 || i2 >= 0) {
              line = line.replace('\t', ' ');
              output.append(line.trim());
              output.append(Konst.NL);
              if (i2 >= 0) doctype = true;
          }
          else {
              // check <html>  doctype=true  html=false
              if (doctype && !html) {
                  i1 = line.toLowerCase().indexOf("<html");
                  if (i1 >= 0) {
                      html = true;
                      line = line.replace('\t', ' ');
                      output.append(line.trim());
                      output.append(Konst.NL);
                      tab = 1;
                  }
                  else {
                      line = line.replace('\t', ' ');
                      output.append(getTabs(tab+1));
                      output.append(line.trim());
                      output.append(Konst.NL);
                      // output.appendLine("  "+line.trim());
                  }
              }
              else {
                  i1 = line.toLowerCase().indexOf("<body");
                  if (i1 >= 0) {
                      line = line.replace('\t', ' ');
                      output.append(line.trim());
                      output.append(Konst.NL);
                      tab = 1;
                  }
                  else {
                      i1 = line.toLowerCase().indexOf("</body>");
                      if (i1 >= 0) {
                          tab--;
                          line = line.replace('\t', ' ');
                          output.append(line.trim());
                          output.append(Konst.NL);
                          continue;
                      }
                      else {
                          i1 = line.toLowerCase().indexOf("</html>");
                          if (i1 >= 0) {
                              tab--;
                              line = line.replace('\t', ' ');
                              output.append(line.trim());
                              output.append(Konst.NL);
                              continue;
                          }
                          else {

                              // separate </head>
                              line = line.replace('\t', ' ').trim();
                              // Reihenfolge ist wichtig, ,    </head>      
                              //     <input type="radio" name="R1" value="CAD1" checked="checked" /> AutoCAD  <br />
                              // Kommentar
                              int anzSpitzAuf1 = anzTextProZeile(line, "<!--");
                              int anzSpitzZu1 = anzTextProZeile(line, "-->");
                              int diff1 = anzSpitzZu1 - anzSpitzAuf1;
                              if (anzSpitzZu1 > 0 && anzSpitzAuf1 > 0) {  // in einer Zeile
                                  output.append(getTabs(tab));
                                  output.append(line.trim());
                                  output.append(Konst.NL);
                              }
                              else {
                                  // <legend>Eingabe</legend>
                                  int anzSpitzAuf2 = anzZeichenProZeileOhneSlash(line, '<');
                                  int anzSpitzZu2a = anzTextProZeile(line, "</");
                                  int anzSpitzZu2b = anzTextProZeile(line, "/>");  // <br />  <input .. />
                                  if ((anzSpitzAuf2 > 0 && anzSpitzZu2a > 0) || (anzSpitzAuf2 > 0 && anzSpitzZu2b > 0)) {  // in einer Zeile
                                      output.append(getTabs(tab));
                                      output.append(line.trim());
                                      output.append(Konst.NL);
                                  }
                                  else {

                                      int anzSpitzAuf3 = anzZeichenProZeileOhneSlash(line, '<');
                                      int anzSpitzZu3 = anzTextProZeile(line, "</");
                                      if (anzSpitzAuf3 == 0 && anzSpitzZu3 > 0) {  // ende 
                                          tab--;
                                          output.append(getTabs(tab));
                                          output.append(line.trim());
                                          output.append(Konst.NL);
                                      }
                                      else {
                                          if (anzSpitzAuf2 > 0) {  // < und /> nicht in einer Zeile
                                              line = line.replace('\t', ' ');
                                              output.append(getTabs(tab));
                                              output.append(line.trim());
                                              tab++;
                                              if (i2 > 0) {
                                                  //tab--;  // ????????????
                                              }
                                          }
                                          else {
                                              line = line.replace('\t', ' ');
                                              output.append(getTabs(tab));
                                              output.append(line.trim());
                                              output.append(Konst.NL);
                                          }
                                      }

                                  }
                              }
                          }

                      }




                  }  // else
              }

          }

      }
      _editor.setText( output.toString() );
      _bModify=true;
      parseText(output.toString());
      // editor.CaretIndex = posTop;
  }  // format
  
  
  private int anzZeichenProZeile(String line, char ch) {
      int summe = 0;
      if (line.length()>0) {
	      char[] chars = line.toCharArray();
	      for (int i = 0; i < line.length(); i++) {
	          if (chars[i] == ch) {
	              summe++;
	          }
	      }
      }
      return summe;
  }

  private int anzZeichenProZeileOhneSlash(String line, char ch) {
      int summe = 0;
      int n = line.length();
      if (n>0) {
    	  char[] chars = line.toCharArray();
	      for (int i = 0; i < n; i++) {
	    	  if (chars[i] == ch) {
	              // check  <in    oder </
	              if (i < n - 1) {
	                  if (chars[i+1] != '/') {
	                      summe++;
	                  }
	              }  // if
	          }  // if
	      }  // for
      }
      return summe;
  }

  //<input type="radio" name="R1" value="CAD1" checked="checked" /> AutoCAD  <br />
  private int anzTextProZeile(String line, String search) {
      int summe = 0;
      String searchLine = line;
      int i = searchLine.indexOf(search);
      while (i >= 0) {
          summe++;
          if (i + 2 < searchLine.length()) {
              searchLine = searchLine.substring(i + 2);
              i = searchLine.indexOf(search);
          }
          else {
              break;
          }
      }
      return summe;
  }

  
  private void formatCSSFile() {
      StringBuilder output = new StringBuilder();  // schneller als ein String                
      String line;
      String[] lines = _editor.getText().replace(Konst.C_TAB, "\t").split(Konst.NL);
      int anzSpitzAuf = 0;
      int anzSpitzZu = 0;
      int offset = 0;
      for (int i = 0; i < lines.length; i++) {
          line = lines[i].replace("\t", "  ").trim();
          if (line.length() == 0) {              
              output.append(Konst.NL);
          }
          else {
              offset = 0;
              String str = output.toString();
              if (line.endsWith("{")) {
                  anzSpitzAuf++;
                  offset = -1;
              }
              if (line.startsWith("}")) {
                  anzSpitzAuf--;
                  anzSpitzZu++;
              }
              output.append(getTabs(anzSpitzAuf+offset));
              output.append(line.trim());
              output.append(Konst.NL);
          }
      }  // for

     // modell.EditText = output.toString();
      _bModify = true;
      parseText(output.toString());  
   }
  
  
  private void formatJavaScriptFile() {
      StringBuilder output = new StringBuilder();  // schneller als ein String                
      int tab = 0;
      String line;
      String[] lines = _editor.getText().replace(Konst.C_TAB, "\t").split(Konst.NL);
      for (int i = 0; i < lines.length; i++) {
          line = lines[i].replace("\t", "  ").trim();
          if (line.length() == 0) {
              output.append(Konst.NL);
          }
          else {
              String str = output.toString();
              boolean anzSpitzAuf = line.endsWith("{");
              boolean anzSpitzZu = line.startsWith("}");
              if (anzSpitzZu) {
                  tab--;  // nur wenn nicht in einer Zeile
                  output.append(getTabs(tab));
                  output.append(line.trim());
                  output.append(Konst.NL);
                  if (tab == 0) output.append(Konst.NL);
              }
              else {
                  if (anzSpitzAuf) {
                      // tab++;
                      line = line.replace('\t', ' ');
                      output.append(getTabs(tab));
                      output.append(line.trim());
                      output.append(Konst.NL);
                      tab++;
                  }
                  else {
                      line = line.replace('\t', ' ');
                      output.append(getTabs(tab));
                      output.append(line.trim());
                      output.append(Konst.NL);
                  }
              }
          }
      }  // for
      //modell.EditText = output.toString();
      _bModify = true;
      parseText(output.toString());	  
  }
  
  public void saveAs(String filename) {
	  String ext = Basis.getFileExt(this.filename).toLowerCase();
	  if (ext.equals(".xhtml") || ext.equals(".html") || ext.equals(".htm") || ext.equals(".php")) {
		  changeCSSFile(this.filename, filename);
	  }
    this.filename = filename;
    setTitle( this.filename );
    // Change xhtml den CSS
    saveFile();
  }
  
  public void changeCSSFile(String oldHTMLFilename, String newHTMLFilename) {
      String path, oldName, newName, ext;
      oldName=Basis.getFileNameExt( Basis.changeFileExt(oldHTMLFilename, "css") );
      newName=Basis.getFileNameExt( Basis.changeFileExt(newHTMLFilename, "css") );
      // suche   href="Vorl_jq8.css"    ersetze  durch href="Vorl_jq9.css"
      String s1 = _editor.getText();
      String s2 = "href=\"" + oldName + "\"";
      int i = _editor.getText().indexOf("href=\"" + oldName + "\"");
      if (i > 0) {
          _editor.setText( _editor.getText().replace("href=\"" + oldName + "\"", "href=\"" + newName + "\"") );
          _bModify = true;
      }
  }  
  
  
  public void saveFile() {
    String sText = _editor.getText().replace(Konst.C_TAB,"\t");
    String[] sLines = sText.split(Konst.NL);
    try {
      FileOutputStream fout = new FileOutputStream(this.filename);
      PrintStream p = new PrintStream(fout);
      for (String sLine : sLines) {
        p.println( ChangeUmlaute(sLine) );
      }
      p.close();
      fout.close();              
      _bModify=false;
    }
    catch (IOException ee) {
        System.err.println("IOException: " + ee);
    }
  }  // saveFile
    
  
    
    String ChangeUmlaute(String sText) 
    {
      sText = ChangeUmlaut("Ä","&#196;", sText);
      sText = ChangeUmlaut("ä","&#228;",sText);
      sText = ChangeUmlaut("Ö","&#214;",sText);
      sText = ChangeUmlaut("ö","&#246;",sText);
      sText = ChangeUmlaut("Ü","&#220;",sText);
      sText = ChangeUmlaut("ü","&#252;",sText);
      sText = ChangeUmlaut("ß","&#223;",sText);
      return sText;
    }


    String ChangeUmlaut(String sChar, String sNewChar, String sText)  {
        int i;
        int al1, al2;
        int startindex;        
        al1 = sText.indexOf("alert");
        if (al1 >= 0)
            al2 = sText.indexOf(")", al1 + 4);
        else
            al2 = -1;

      i = sText.indexOf(sChar);  // CurrentCultureIgnoreCase
      while (i>=0) {

          //if (((i >= ji1) && (i <= ji2)) || ((i >= pi1) && (i <= pi2)) || ((i >= qi1) && (i <= qi2)))
          if ( (al1>=0)   && (i >= al1) && (i <= al2) )
              startindex = i + 1;
          else
          {            
              sText = sText.substring(0, i) + sNewChar + sText.substring(i+1); // funktioniert nur, wenn sChar Laenge 1 ist 
              startindex = i + 1;
          }
        //  al1 = sText.IndexOf("alert", startindex, StringComparison.CurrentCultureIgnoreCase);
        //if (al1 >= 0)
        //    al2 = sText.IndexOf(")", al1 + 4, StringComparison.CurrentCultureIgnoreCase);
        //else
        //    al2 = -1;
          i = sText.indexOf(sChar, startindex);             
      }  // ChangeUmlaut      
      return sText;
    }  // ChangeUmlaut
    
    public void cut() {
    	String text = _editor.getSelectedText().replace(Konst.C_TAB,"\t");
        _editor.cut();
  	  StringSelection selection = new StringSelection(text);
  	  Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
  	  clipboard.setContents(selection, selection);
    }
    public void copy() {
    	String text = _editor.getSelectedText().replace(Konst.C_TAB,"\t");
      //_editor.copy();
	  StringSelection selection = new StringSelection(text);
	  Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
	  clipboard.setContents(selection, selection);
      
    }
    
    // import java.awt.datatransfer.*; 
    public void paste() {
    	Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
    	Transferable clipData = clipboard.getContents(this); 
        try    { 
            String s1 = (String)clipData.getTransferData(DataFlavor.stringFlavor); 
            String s = s1.replaceAll(Konst.C_TAB, "  ");
            s = s.replaceAll("\t", "  ");
            StringSelection clipString =new StringSelection(s); 
            clipboard.setContents(clipString,clipString); 
            _editor.paste();            
            _bModify = true;
             
       }   
        catch(Exception ex)    { 
              System.err.println("Not Working"); 
        } 
  
    }
    public void selectAll() {
      _editor.selectAll();
    }
    
    public  void setFontSize(int fontsize) {
    	this.fontsize = fontsize;
    	_lineeditor.setFont( new Font("Courier New", Font.PLAIN,fontsize)  );
  	   _editor.setFont( new Font("Courier New", Font.PLAIN,fontsize)  );
  	   caretListenerLabel.setFont( new Font("Verdana", Font.PLAIN,fontsize)  );
  	 addStylesToDocument(styledDoc);
  	 String s = _editor.getText().replace(Konst.C_TAB, "\t");
  	 parseText(s);
    }


    public void updateOptionSession() {
   	 
    }
    
    public void lightmode() {
    	colorHTML = Color.BLUE;
    	colorNormalText = Color.BLACK;
    	colorSpecialChars = Color.RED;
    	colorComment = new Color(185,122,87);
    //	colorLightBlue = new Color(100,100,255);
    	colorLinenumber = new Color(100,100,255);
    	colorBackground = Color.WHITE;  
    	
    	_lineeditor.setBackground(colorBackground);
    	_lineeditor.setForeground(colorHTML);
    	
    	_editor.setCaretColor(Color.BLACK);
    	_editor.setBackground(Color.WHITE);
    	 addStylesToDocument(styledDoc);
     	 String s = _editor.getText().replace(Konst.C_TAB, "\t");
     	 parseText(s);
     	format();
    }
    public void darkmode() {
    	colorHTML = new Color(237,114,59);
    	colorNormalText = Color.WHITE;
    	colorSpecialChars = Color.RED;
    	colorComment = new Color(104,249,100);
    	//colorLightBlue = new Color(100,100,255);
    	colorLinenumber = new Color(100,100,255);
    	colorBackground = new Color(60,60,60);  
    	
    	_lineeditor.setBackground(colorBackground);
    	_lineeditor.setForeground(colorHTML);
    	
    	_editor.setCaretColor(Color.WHITE);
    	_editor.setBackground(colorBackground);
    	
    	addStylesToDocument(styledDoc);
     	 String s = _editor.getText().replace(Konst.C_TAB, "\t");
     	 parseText(s);
     	 format();
    }
         
}
