﻿import javax.swing.*;
import javax.swing.border.LineBorder;
import javax.swing.border.TitledBorder;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.io.File;
import java.util.Vector;

import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import javax.swing.text.*;

@SuppressWarnings("serial")
public class FShowOptions extends JDialog{
	
	private boolean isWindows=true;
	
    public boolean bResult=false;
  private JButton bnOk = new JButton("Ok");
  private JButton bnEsc = new JButton("Cancel");

  JTabbedPane jTabbedPane1 = new JTabbedPane(JTabbedPane.TOP);
  
  JSpinner sp_Tabs = null;
  JSpinner nud_FontSize = new JSpinner( new SpinnerNumberModel(2,1, 100, 1)   );

  JTextField tSafari = new JTextField();
  JTextField tFirefox = new JTextField();
  JTextField tChrome = new JTextField();
  JTextField tOpera = new JTextField();
  
  JTextField tBrowser5 = new JTextField();
  JTextField tBrowser6 = new JTextField();

  JButton bnSafari = new JButton("...");
  JButton bnFirefox = new JButton("...");
  JButton bnChrome = new JButton("...");
  JButton bnOpera = new JButton("...");
  JButton bnBrowser5 = new JButton("...");
  
  JRadioButton rb80 = new JRadioButton("$80", false);
  JRadioButton rb81 = new JRadioButton("$81", false);
  JRadioButton rb8080 = new JRadioButton("$8080", false);
  JRadioButton rb8081 = new JRadioButton("$8081", false);
  
  JTextPane labeltextpanetab = new JTextPane();
   Vector<String> tabliste = new Vector<String>();
   private StyledDocument styledDoc = null;
   private	AbstractDocument doc = null;

  
public FShowOptions(Frame parent) {
    super(parent);	// oder super(parent, true);
    
    setModal(true);
    bResult=false;
    setSize(680, 450);
    setTitle("Properties of iHTML");    
    String os = System.getProperty("os.name");  //  os.arch  amd64  ia64   x86     Windows 10
	System.out.println("os: "+os);

	if (os.equals("Windows 10") || os.equals("Windows 7")) {
		isWindows = true;
	} else {
		isWindows = false;
	}
    
    setGUI();
    setVisible(true);
  }

 private void setGUI() {
    this.getContentPane().setLayout( new GridBagLayout() );
    JLabel label1 = new JLabel("Properties of iHTML");
    label1.setFont( new Font("Arial", Font.BOLD,16)  );
    label1.setForeground(Color.blue);
    
     this.getContentPane().add( label1,
       new GridBagConstraints(
           0, 0, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(20,20,30,0), 0, 0));
    
    jTabbedPane1.setFont( new Font("Arial", Font.PLAIN,18));
    jTabbedPane1.setTabPlacement( JTabbedPane.TOP);
    
    jTabbedPane1.addTab("Editor-Options", null, createPanel1() );
    jTabbedPane1.addTab("Safari", null, createPanelSafari() );
    jTabbedPane1.addTab("Firefox", null, createPanelFirefox() );
    jTabbedPane1.addTab("Chrome", null, createPanelChrome() );
    jTabbedPane1.addTab("Opera", null, createPanelOpera() );
    jTabbedPane1.addTab("5. Browser", null, createPanelBrowser5() );
    jTabbedPane1.addTab("PHP-Ports", null, createPanel3() );
    
    this.getContentPane().add(jTabbedPane1,
       new GridBagConstraints(
           0,1, 1, 1, 100.0, 100.0
      ,GridBagConstraints.CENTER,
      GridBagConstraints.BOTH,
         new Insets(0,0,10,0), 0, 0));  // Top left Bottom Right

    
    JPanel panelBn = new JPanel(); 
    panelBn.setLayout( new FlowLayout() );
    panelBn.add(bnOk);
    panelBn.add(bnEsc);  
    bnOk.setFont( new Font("Arial", Font.PLAIN,12)  );
    bnEsc.setFont( new Font("Arial", Font.PLAIN,12)  );
    bnOk.setPreferredSize(  bnEsc.getPreferredSize() );
    this.getContentPane().add(panelBn,
       new GridBagConstraints(
           0,2, 1, 1, 100.0, 0.0
      ,GridBagConstraints.CENTER,
      GridBagConstraints.HORIZONTAL,
         new Insets(20,0,10,0), 0, 0));  // Top left Bottom Right
     
    bnOk.addActionListener(new java.awt.event.ActionListener() {
      @Override
      public void actionPerformed(ActionEvent e) {
        bnOK_click();
      }
    });
    bnEsc.addActionListener(new java.awt.event.ActionListener() {
      @Override
      public void actionPerformed(ActionEvent e) {
        bnEsc_click();
      }
    });    
   }  // setGUI
 
 private void setRTF2() {
	  styledDoc = labeltextpanetab.getStyledDocument();
		 if (styledDoc instanceof AbstractDocument) {
	            doc = (AbstractDocument)styledDoc;
	            //doc.setDocumentFilter(new DocumentSizeFilter(MAX_CHARACTERS));
	        } else {
	            System.err.println("Text pane's document isn't an AbstractDocument!");
	            System.exit(-1);
	        }		 
		 addStylesToDocument(styledDoc);
}
 
 protected void addStylesToDocument(StyledDocument doc) {
     //Initialize some styles.
     Style def = StyleContext.getDefaultStyleContext().getStyle(StyleContext.DEFAULT_STYLE);

     Style regular = doc.addStyle("regular", def);
     StyleConstants.setFontFamily(def, "Courier New");
     StyleConstants.setFontSize(regular, 24);
     
    // StyleConstants.setForeground(regular, colorNormalText );
     
     Style s = doc.addStyle("html", def);
     StyleConstants.setFontFamily(def, "Courier New");
     StyleConstants.setBackground(s, Color.WHITE);
     StyleConstants.setForeground(s, Color.BLACK);
      StyleConstants.setFontSize(s, 24);           
 }
 
 JPanel createPanel1() {
    JPanel panel = new JPanel();
    panel.setLayout( new GridBagLayout() );
    panel.setBackground(Color.lightGray);
    
    JLabel label1 = new JLabel("Select the tab");
    label1.setFont( new Font("Arial", Font.PLAIN,14) );
    panel.add( label1,
       new GridBagConstraints(
           0, 0, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(10,20,20,0), 0, 0));

    SingVar instance = SingVar.getInstance(); 
    
    setRTF2();
    for(int tabcode : Konst.C_TABSUNICODE) {
    	tabliste.add(  Character.toString((char)tabcode)  );
    }
    
    sp_Tabs = new JSpinner( new SpinnerNumberModel(0,0, tabliste.size()-1, 1)   );    
    sp_Tabs.setFont( new Font("Arial", Font.PLAIN,14) );
    //sp_Tabs.setSelectedIndex( 0 );
    sp_Tabs_click();
    
    panel.add( sp_Tabs,
       new GridBagConstraints(
           1, 0, 1, 1, 100.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.HORIZONTAL,
         new Insets(10,20,20,50), 0, 0));

    sp_Tabs.addChangeListener(new javax.swing.event.ChangeListener() {
        public void stateChanged(javax.swing.event.ChangeEvent evt) {
        	sp_Tabs_click();
        }
    });

    
    labeltextpanetab.setFont( new Font("Arial", Font.PLAIN,24) );
     panel.add( labeltextpanetab,
       new GridBagConstraints(
           1, 1, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(10,20,0,2), 0, 0));    
     

    JLabel label2 = new JLabel("Font size");
    label2.setFont( new Font("Arial", Font.PLAIN,14) );
     panel.add( label2,
       new GridBagConstraints(
           0, 2, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(10,20,0,2), 0, 0));

    
    nud_FontSize.setValue( new Integer(instance.getFontsize()) );
    nud_FontSize.setFont( new Font("Arial", Font.PLAIN,14) );
    
    panel.add( nud_FontSize,
       new GridBagConstraints(
           1, 2, 1, 1, 100.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.HORIZONTAL,
         new Insets(10,20,0,50), 0, 0));
     
     
     return panel;

} // createPanel1



 JPanel createPanelSafari() {
	 SingVar instance = SingVar.getInstance();
	 
    JPanel panel = new JPanel();
    panel.setLayout( new GridBagLayout() );
    panel.setBackground(Color.lightGray);
    
    JLabel label1 = new JLabel("Safari");
    label1.setFont( new Font("Arial", Font.PLAIN,14) );
    panel.add( label1,
       new GridBagConstraints(
           0, 0, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(10,20,20,0), 0, 0));      
    
    tSafari.setText( instance.getSafari() );
    tSafari.setFont( new Font("Arial", Font.PLAIN,14) );
    
    panel.add( tSafari,
       new GridBagConstraints(
           1, 0, 1, 1, 100.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.HORIZONTAL,
         new Insets(10,20,20,10), 0, 0));

    bnSafari.setFont( new Font("Arial", Font.PLAIN,14) );
    panel.add( bnSafari,
       new GridBagConstraints(
           2, 0, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(10,0,20,20), 0, 0));
    
  
    
    JLabel label2 = new JLabel("samples of the paths of safari");
    label2.setFont( new Font("Arial", Font.PLAIN,14) );
    panel.add( label2,
       new GridBagConstraints(
           0, 1, 3, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(10,20,0,0), 0, 0));      
    
    String paths = "/\"Computer\"/Application/Safari.App" ; 
	  		 
    JTextArea helpEditor = new JTextArea(paths);
    helpEditor.setFont( new Font("Arial", Font.PLAIN,14) );
		
    if (isWindows) {
    	tSafari.setEnabled(false);
    	bnSafari.setEnabled(false);
    	helpEditor.setEnabled(false);
    }    
    
    panel.add( helpEditor,
       new GridBagConstraints(
           0, 2, 2, 1, 100.0, 100.0,
      GridBagConstraints.EAST,
      GridBagConstraints.BOTH,
         new Insets(0,20,20,0), 0, 0));      
    
    
    bnSafari.addActionListener(new java.awt.event.ActionListener() {
        @Override
        public void actionPerformed(ActionEvent e) {
        	bnSafari_click();
        }
      });
     
     return panel;
} // createPanelSafari
 

 JPanel createPanelFirefox() {
	 SingVar instance = SingVar.getInstance();
	 
    JPanel panel = new JPanel();
    panel.setLayout( new GridBagLayout() );
    panel.setBackground(Color.lightGray);
    
    JLabel label1 = new JLabel("Firefox");
    label1.setFont( new Font("Arial", Font.PLAIN,14) );
    panel.add( label1,
       new GridBagConstraints(
           0, 0, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(10,20,20,0), 0, 0));      
    
    tFirefox.setText( instance.getSafari() );
    tFirefox.setFont( new Font("Arial", Font.PLAIN,14) );
    
    panel.add( tFirefox,
       new GridBagConstraints(
           1, 0, 1, 1, 100.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.HORIZONTAL,
         new Insets(10,20,20,10), 0, 0));

    bnFirefox.setFont( new Font("Arial", Font.PLAIN,14) );
    panel.add( bnFirefox,
       new GridBagConstraints(
           2, 0, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(10,0,20,20), 0, 0));
    
    
    
    JLabel label2 = new JLabel("samples of the paths of firefox");
    label2.setFont( new Font("Arial", Font.PLAIN,14) );
    panel.add( label2,
       new GridBagConstraints(
           0, 1, 3, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(10,20,0,0), 0, 0));      
    
    String paths;
    if (isWindows)
     paths = "C:\\Program Files\\Mozilla Firefox\\firefox.exe\r\n" + 
	  		"C:\\Program Files (x86)\\Mozilla Firefox\\firefox.exe\r\n" + 
	  		"C:\\Users\\User1\\AppData\\Local\\Programs\\Mozilla Firefox\\firefox.exe\r\n" ;
    else
    	paths = "/\"Computer\"/Application/Firefox.App" ;
	  		 
	  		
    JTextArea helpEditor = new JTextArea(paths);
    helpEditor.setFont( new Font("Arial", Font.PLAIN,14) );
    panel.add( helpEditor,
       new GridBagConstraints(
    		   0, 2, 2, 1, 100.0, 100.0,
           GridBagConstraints.EAST,
           GridBagConstraints.BOTH,
         new Insets(0,20,20,0), 0, 0));      
    
    bnFirefox.addActionListener(new java.awt.event.ActionListener() {
        @Override
        public void actionPerformed(ActionEvent e) {
        	bnFirefox_click();
        }
      });
     
     return panel;
} // createPanelFirefox
 

 JPanel createPanelChrome() {
	 SingVar instance = SingVar.getInstance();
	 
    JPanel panel = new JPanel();
    panel.setLayout( new GridBagLayout() );
    panel.setBackground(Color.lightGray);
    
    JLabel label1 = new JLabel("Chrome");
    label1.setFont( new Font("Arial", Font.PLAIN,14) );
    panel.add( label1,
       new GridBagConstraints(
           0, 0, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(10,20,20,0), 0, 0));      
    
    tChrome.setText( instance.getChrome() );
    tChrome.setFont( new Font("Arial", Font.PLAIN,14) );
    
    panel.add( tChrome,
       new GridBagConstraints(
           1, 0, 1, 1, 100.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.HORIZONTAL,
         new Insets(10,20,20,10), 0, 0));

    bnChrome.setFont( new Font("Arial", Font.PLAIN,14) );
    panel.add( bnChrome,
       new GridBagConstraints(
           2, 0, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(10,0,20,20), 0, 0));
    
    
    
    JLabel label2 = new JLabel("samples of the paths of chrome");
    label2.setFont( new Font("Arial", Font.PLAIN,14) );
    panel.add( label2,
       new GridBagConstraints(
           0, 1, 3, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(10,20,0,0), 0, 0));      
    
    String paths;
    if (isWindows)
    	 paths = "C:\\Users\\User1\\AppData\\Local\\Programs\\Chrome\\chrome.exe\r\n" + 
    		  		"C:\\Program Files (x86)\\Google\\Chrome\\Application\\chrome.exe\r\n" + 
    		  		"C:\\Program Files\\Google\\Chrome\\Application\\chrome.exe";
    else
    	paths = "/\"Computer\"/Application/Chrome.App" ;
	  		
    JTextArea helpEditor = new JTextArea(paths);
    helpEditor.setFont( new Font("Arial", Font.PLAIN,14) );
    panel.add( helpEditor,
       new GridBagConstraints(
    		   0, 2, 2, 1, 100.0, 100.0,
           GridBagConstraints.EAST,
           GridBagConstraints.BOTH,
         new Insets(0,20,20,0), 0, 0));      
    
    bnChrome.addActionListener(new java.awt.event.ActionListener() {
        @Override
        public void actionPerformed(ActionEvent e) {
        	bnChrome_click();
        }
      });
     
     return panel;
} // createPanelChrome
 
 

 JPanel createPanelOpera() {
	 SingVar instance = SingVar.getInstance();
	 
    JPanel panel = new JPanel();
    panel.setLayout( new GridBagLayout() );
    panel.setBackground(Color.lightGray);
    
    JLabel label1 = new JLabel("Opera");
    label1.setFont( new Font("Arial", Font.PLAIN,14) );
    panel.add( label1,
       new GridBagConstraints(
           0, 0, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(10,20,20,0), 0, 0));      
    
    tOpera.setText( instance.getOpera() );
    tOpera.setFont( new Font("Arial", Font.PLAIN,14) );
    
    panel.add( tOpera,
       new GridBagConstraints(
           1, 0, 1, 1, 100.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.HORIZONTAL,
         new Insets(10,20,20,10), 0, 0));

    bnOpera.setFont( new Font("Arial", Font.PLAIN,14) );
    panel.add( bnOpera,
       new GridBagConstraints(
           2, 0, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(10,0,20,20), 0, 0));
    
    
    
    JLabel label2 = new JLabel("samples of the paths of opera");
    label2.setFont( new Font("Arial", Font.PLAIN,14) );
    panel.add( label2,
       new GridBagConstraints(
           0, 1, 3, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(10,20,0,0), 0, 0));      
    
    String paths;
    if (isWindows)
    	paths =	"C:\\Program Files\\Opera\\Application\\opera.exe\r\n" + 
    	  		"C:\\Program Files (x86)\\Opera\\opera.exe\r\n" + 
    	  		"C:\\Users\\User1\\AppData\\Local\\Programs\\Opera\\66.0.3515.72\\opera.exe";
    else
    	paths = "/\"Computer\"/Application/Opera.App" ;
    
    	  		
	  		
    JTextArea helpEditor = new JTextArea(paths);
    helpEditor.setFont( new Font("Arial", Font.PLAIN,14) );
    panel.add( helpEditor,
       new GridBagConstraints(
    		   0, 2, 2, 1, 100.0, 100.0,
           GridBagConstraints.EAST,
           GridBagConstraints.BOTH,
         new Insets(0,20,20,0), 0, 0));      
    
    bnOpera.addActionListener(new java.awt.event.ActionListener() {
        @Override
        public void actionPerformed(ActionEvent e) {
        	bnOpera_click();
        }
      });
     
     return panel;
} // createPanelOpera
 

 JPanel createPanelBrowser5() {
	 SingVar instance = SingVar.getInstance();
	 
    JPanel panel = new JPanel();
    panel.setLayout( new GridBagLayout() );
    panel.setBackground(Color.lightGray);
    
    JLabel label1 = new JLabel("5. Browser");
    label1.setFont( new Font("Arial", Font.PLAIN,14) );
    panel.add( label1,
       new GridBagConstraints(
           0, 0, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(10,20,20,0), 0, 0));      
    
    tBrowser5.setText( instance.getBroswer5() );
    tBrowser5.setFont( new Font("Arial", Font.PLAIN,14) );
    
    panel.add( tBrowser5,
       new GridBagConstraints(
           1, 0, 1, 1, 100.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.HORIZONTAL,
         new Insets(10,20,20,10), 0, 0));

    bnBrowser5.setFont( new Font("Arial", Font.PLAIN,14) );
    panel.add( bnBrowser5,
       new GridBagConstraints(
           2, 0, 1, 1, 0.0, 0.0
      ,GridBagConstraints.WEST,
      GridBagConstraints.NONE,
         new Insets(10,0,20,20), 0, 0));
    
    
    
    
    bnBrowser5.addActionListener(new java.awt.event.ActionListener() {
        @Override
        public void actionPerformed(ActionEvent e) {
        	bnOpera_click();
        }
      });
     
     return panel;
} // createPanelBrowser5
 
 JPanel createPanel3() {
	    JPanel panel = new JPanel();
	    
	    panel.setLayout( new GridBagLayout() );
	    panel.setBackground(Color.lightGray);
	    
	    rb80.setFont( new Font("Arial", Font.PLAIN, 14)  );
	    rb81.setFont( new Font("Arial", Font.PLAIN, 14)  );
	    rb8080.setFont( new Font("Arial", Font.PLAIN, 14)  );
	    rb8081.setFont( new Font("Arial", Font.PLAIN, 14)  );
	    
	    ButtonGroup group1 = new ButtonGroup();
	    group1.add(rb80);
	    group1.add(rb81);
	    group1.add(rb8080);
	    group1.add(rb8081);
	    
	    TitledBorder tb = new TitledBorder( LineBorder.createBlackLineBorder(),   "PHP-Ports");
	   panel.setBorder(tb);
	    
	    SingVar instance = SingVar.getInstance();
	    int port = instance.getPhpPort();
	    switch (port) {
	    case 80: 	rb80.setSelected(true);
						break;
	    case 81: 	rb81.setSelected(true);
						break;
	    case 8080: 	rb8080.setSelected(true);
						break;
	    case 8081: 	rb8081.setSelected(true);
							break;
	    default:	rb80.setSelected(true);
						break;
	    }
	    
	    panel.add( rb80,
	       new GridBagConstraints(
	           0, 0, 1, 1, 100.0, 0.0
	      ,GridBagConstraints.WEST,
	      GridBagConstraints.HORIZONTAL,
	         new Insets(10,20,10,50), 0, 0));

	    panel.add( rb81,
	 	       new GridBagConstraints(
	 	           0, 1, 1, 1, 100.0, 0.0
	 	      ,GridBagConstraints.WEST,
	 	      GridBagConstraints.HORIZONTAL,
	 	     new Insets(10,20,10,50), 0, 0));
	     
	    panel.add( rb8080,
	 	       new GridBagConstraints(
	 	           0, 2, 1, 1, 100.0, 0.0
	 	      ,GridBagConstraints.WEST,
	 	      GridBagConstraints.HORIZONTAL,
	 	     new Insets(10,20,10,50), 0, 0));
	    
	    panel.add( rb8081,
		 	       new GridBagConstraints(
		 	           0, 3, 1, 1, 100.0, 0.0
		 	      ,GridBagConstraints.WEST,
		 	      GridBagConstraints.HORIZONTAL,
		 	     new Insets(10,20,10,50), 0, 0));
		    	    
	     
	     return panel;

	} // createPanel3

 private void Browser_click(JTextField tBrowser) {
   JFileChooser jFileChooser1;
   jFileChooser1 = new JFileChooser();
   jFileChooser1.setMultiSelectionEnabled(false);
   jFileChooser1.setCurrentDirectory(  new File(  (String) System.getProperties().get("user.dir")  )   );
   jFileChooser1.addChoosableFileFilter(  new MyFileFilter( "exe", "Programme (*.exe)")  );
   
   jFileChooser1.setPreferredSize(new Dimension(1000,600));
   jFileChooser1.setDialogTitle("select the browser");
     // Okay gedrückt ?
    if (JFileChooser.APPROVE_OPTION == jFileChooser1.showOpenDialog(this)) {
      String sFile = jFileChooser1.getSelectedFile().getPath();
      String sFileNew="";
      for (char ch : sFile.toCharArray()) {
        if (ch==920000) 
          sFileNew+="\\";
        else
          sFileNew+=ch;
      }
      tBrowser.setText( sFileNew );
    }   
 }  // Browser_click

 private void bnSafari_click() {
	   Browser_click(tSafari);
	 }
 private void bnFirefox_click() {
	   Browser_click(tFirefox);
	 }
 private void bnChrome_click() {
	   Browser_click(tChrome);
	 }
 private void bnOpera_click() {
	   Browser_click(tOpera);
	 }

 
 private void bnBrowser5_click() {
   Browser_click(tBrowser5);
 }
 private void bnBrowser6_click() {
   Browser_click(tBrowser6);
 }
 
 private void sp_Tabs_click() {
	 int i  = (int) sp_Tabs.getValue();
	 labeltextpanetab.setText("");
	 //String s   	=  String.valueOf(Character.toChars( Konst.C_TABSUNICODE[i] )  );
	 String s = Konst.C_TABS[i]+"let count = 42;";
	 
	 try {
		 if (styledDoc!=null) {
			 System.out.println(s);
			 styledDoc.insertString(styledDoc.getLength(), s, styledDoc.getStyle("html"));
		 }
		 else {
			 System.out.println("styledDoc ist null");
		 }
	 } catch (BadLocationException e) {
			System.err.println("Couldn't insert initial text into text pane.");
	}
	 // labeltextpanetab.setText(s);
 }
 
  private void  bnOK_click() { 
    //sFunctionname = TFunctionname.getText().trim();
	  SingVar instance = SingVar.getInstance();  
	    
	  instance.setSafari(tSafari.getText().trim());
	  instance.setFirefox(tFirefox.getText().trim());
	  instance.setChrome(tChrome.getText().trim());
	  instance.setOpera(tOpera.getText().trim());
   
    instance.setBroswer5(tBrowser5.getText().trim());
    instance.setBroswer6(tBrowser6.getText().trim());
    
    Integer I = (Integer) nud_FontSize.getValue();
    instance.setFontsize(I.intValue());
    
    for (int i=0; i<tabliste.size(); i++) {
    	
    }
    int i  = (int) sp_Tabs.getValue();
  //  int i = sp_Tabs.getSelectedIndex();    
    instance.setTabindex(i);
    
    int port = 80;
    if (rb80.isSelected()) {
    	port = 80;
    }
    if (rb81.isSelected()) {
    	port = 81;
    }
    if (rb8080.isSelected()) {
    	port = 8080;
    }
    if (rb8081.isSelected()) {
    	port = 8081;
    }
    instance.setPhpPort(port);
    
    instance.writeProperties();

    bResult=true;
    setVisible(false);
    dispose();
    
  }

  private void  bnEsc_click() {
    bResult=false;
    setVisible(false);
    dispose();
  }
  
  
}
