import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

// Packages fuer Opendialog
import java.io.File;
import java.io.IOException;

import javax.swing.event.InternalFrameEvent;
import javax.swing.filechooser.*;

import javax.swing.event.InternalFrameListener;

import java.awt.datatransfer.*;

public class IHTMLRtfTab extends JFrame implements ActionListener {

	private int fontsize = 18;

	private SingVar singvar = null;
	private boolean isWindows=true;
	private boolean isOS=false;
	
	private int CTRL=ActionEvent.CTRL_MASK;
	
//	private JTabbedPane tabbedpane = new JTabbedPane(JTabbedPane.TOP);
	private DraggableTabbedPane tabbedpane = new DraggableTabbedPane();
		
	
	private JMenuBar menuBar1; // MenueContainer
	private JMenu mainFont = new JMenu("Font");

	JButton bnSafari = new JButton("Safari");
	JButton bnFirefox = new JButton("Firefox");
	JButton bnOpera = new JButton("Opera");
	JButton bnChrome = new JButton("Chrome");
	JCheckBox chkRunTab0 = new JCheckBox("run the first tab");


	JButton bnOpen = new JButton("Open");
	JButton bnNew = new JButton("New");
	JButton bnSave = new JButton("Save");
	JButton bnSaveAll = new JButton("Save All");

	

	public IHTMLRtfTab() {
		this.setSize(900, 700);
		setTitle("i HTML RTF Tab");
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		singvar = SingVar.getInstance();
		singvar.readProperties();
	    String os = System.getProperty("os.name");  //  os.arch  amd64  ia64   x86     Windows 10
		
		  if (os.equals("Windows 10")  || os.equals("Windows 7")) {
		        isWindows=true;
			  }
			  else {
				  isWindows=false;
			  }    
		  if (os.indexOf("MAC")>=0) {
		        isOS=true;
		        CTRL=ActionEvent.META_MASK;
			  }
			  else {
				  isOS=false;
			  }   		this.fontsize = singvar.getFontsize();
		setGUI();
	}

	public void setGUI() {
		// BorderLayout setzen
		this.getContentPane().setLayout(new BorderLayout());

		// Variable DesktopPane einfuegen
		// in ihr werden alle Clientfenster eingefuegt
		add(tabbedpane, BorderLayout.CENTER);
		//tabbedpane.add("111",new JPanel());
		setMenus();
		setToolBars();
		setFontsize(this.fontsize);
		// installLnF();
		try {
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel");
			SwingUtilities.updateComponentTreeUI(this.getContentPane()); // alles neuzeichnen
			return;
		} catch (Exception elook) {
		}

	} // setGUI

	// setzt die Menues
	private void setMenus() {
		menuBar1 = new JMenuBar();

		// DATEI
		JMenu mainFile = new JMenu("File");
		JMenuItem mnNew = new JMenuItem("New");
		JMenuItem mnOpen = new JMenuItem("Open");
		JMenuItem mnSave = new JMenuItem("Save");
		JMenuItem mnSaveAs = new JMenuItem("Save as");

		JMenuItem mnSaveAllFiles = new JMenuItem("Save all files");
		JMenuItem mnCalc = new JMenuItem("calc");
		JMenuItem mnDos = new JMenuItem("Dos");
		JMenuItem mnNotepad = new JMenuItem("Notepad");
		JMenuItem mnExplorer = new JMenuItem("Explorer");

		JMenuItem mnClose = new JMenuItem("Close");

		// Event definieren
		mnNew.addActionListener(this);
		mnNew.setActionCommand("NewFile");
		// Short Key definieren STRG+N
		mnNew.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, ActionEvent.CTRL_MASK));
		mainFile.add(mnNew);

		// Event definieren
		mnOpen.addActionListener(this);
		mnOpen.setActionCommand("OpenFile");
		// Short Key definieren STRG+O
		mnOpen.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O, ActionEvent.CTRL_MASK));
		// Menueeintraege zum mainFile hinzufuegen
		mainFile.add(mnOpen);

		mnSave.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, ActionEvent.CTRL_MASK));
		mnSave.addActionListener(this);
		mnSave.setActionCommand("SaveFile");

		mnSaveAs.addActionListener(this);
		mnSaveAs.setActionCommand("SaveAsFile");
		mnSaveAs.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F12, 0));

		mnSaveAllFiles.addActionListener(this);
		mnCalc.addActionListener(this);
		mnDos.addActionListener(this);
		mnNotepad.addActionListener(this);
		mnExplorer.addActionListener(this);

		mnSaveAllFiles.setActionCommand("SaveAllFiles");
		mnCalc.setActionCommand("Calc");
		mnDos.setActionCommand("Dos");
		mnNotepad.setActionCommand("Notepad");
		mnExplorer.setActionCommand("Explorer");
		
		  if (!isWindows) {
		    	mnNotepad.setEnabled(false);
		    	mnExplorer.setEnabled(false);
		    }		

		mainFile.add(mnSave);
		mainFile.add(mnSaveAs);
		mainFile.add(mnSaveAllFiles);
		mainFile.addSeparator();
		mainFile.add(mnCalc);
		mainFile.add(mnDos);
		mainFile.add(mnNotepad);
		mainFile.add(mnExplorer);

		mainFile.addSeparator();

		// --------------------------
		// Event definieren
		mnClose.addActionListener(this);
		mnClose.setActionCommand("Close");
		mainFile.add(mnClose);

		// Hauptmenue FILE in den MenueBar einfuegen
		menuBar1.add(mainFile);

		JMenu mainEdit = new JMenu("Edit");
		menuBar1.add(mainEdit);
		JMenuItem mnCut = new JMenuItem("Cut");
		JMenuItem mnCopy = new JMenuItem("Copy");
		JMenuItem mnPaste = new JMenuItem("Paste");
		JMenuItem mnSelectAll = new JMenuItem("Select all");
		
		mnCut.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, CTRL));
		mnCopy.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C, CTRL));
		mnPaste.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, CTRL));
		mnSelectAll.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A, CTRL));
		

		mnCut.addActionListener(this);
		mnCut.setActionCommand("Cut");
		mnCopy.addActionListener(this);
		mnCopy.setActionCommand("Copy");
		mnPaste.addActionListener(this);
		mnPaste.setActionCommand("Paste");
		mnSelectAll.addActionListener(this);
		mnSelectAll.setActionCommand("SelectAll");

		mainEdit.add(mnCut);
		mainEdit.add(mnCopy);
		mainEdit.add(mnPaste);
		mainEdit.add(mnSelectAll);

		// ------
		JMenu mainView = new JMenu("View");
		menuBar1.add(mainView);
		JMenuItem mnFormat = new JMenuItem("Format the text");
		mnFormat.addActionListener(this);
		mnFormat.setActionCommand("Format");
		mnFormat.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F9, 0));
		mainView.add(mnFormat);

		mainView.addSeparator();
		JMenuItem mnCloseTab = new JMenuItem("Close tab");
		mnCloseTab.addActionListener(this);
		mnCloseTab.setActionCommand("CloseTab");
		mnCloseTab.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F4, ActionEvent.CTRL_MASK));
		mainView.add(mnCloseTab);
		
//		JMenuItem mnTab2Left = new JMenuItem("Register 2 the left");
//		mnTab2Left.addActionListener(this);
//		mnTab2Left.setActionCommand("Tab2left");
//		mnTab2Left.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_L, ActionEvent.CTRL_MASK));
//		mainView.add(mnTab2Left);
//
//		JMenuItem mnTab2Right = new JMenuItem("Register 2 the right");
//		mnTab2Right.addActionListener(this);
//		mnTab2Right.setActionCommand("Tab2right");
//		mnTab2Right.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_R, ActionEvent.CTRL_MASK));
//		mainView.add(mnTab2Right);

		mainView.addSeparator();

		JMenuItem mnDarkmode = new JMenuItem("Dark mode");
		mnDarkmode.addActionListener(this);
		mnDarkmode.setActionCommand("Darkmode");
		mainView.add(mnDarkmode);

		JMenuItem mnLightmode = new JMenuItem("Light mode");
		mnLightmode.addActionListener(this);
		mnLightmode.setActionCommand("Lightmode");
		mainView.add(mnLightmode);
		// --

		// JMenu mainFont = new JMenu("Font");
		menuBar1.add(mainFont);
		for (int i = 8; i <= 40; i += 2) {
			MyJCheckBoxMenuItem mnFont = new MyJCheckBoxMenuItem(Integer.toString(i) + " pg", i);
			mnFont.setActionCommand("fontsize");
			mnFont.addActionListener(this);
			mainFont.add(mnFont);
		}

		// -------------------
		JMenu mainRun = new JMenu("Run");
		menuBar1.add(mainRun);
		JMenuItem mnStandard = new JMenuItem("Standard Browser");
		JMenuItem mnSafari = new JMenuItem("Safari");
		JMenuItem mnFirefox = new JMenuItem("Firefox");
		JMenuItem mnOpera = new JMenuItem("Opera");
		JMenuItem mnChrome = new JMenuItem("Chrome");
		JMenuItem mnBrowser5 = new JMenuItem("5. Browser");

		mainRun.add(mnStandard);
		mainRun.add(mnSafari);
		mainRun.add(mnFirefox);
		mainRun.add(mnOpera);
		mainRun.add(mnChrome);
		mainRun.add(mnBrowser5);

		mnStandard.addActionListener(this);
		mnStandard.setActionCommand("StandardBrowser");
		mnSafari.addActionListener(this);
		mnSafari.setActionCommand("Safari");
		mnFirefox.addActionListener(this);
		mnFirefox.setActionCommand("Firefox");
		mnOpera.addActionListener(this);
		mnOpera.setActionCommand("Opera");
		mnChrome.addActionListener(this);
		mnChrome.setActionCommand("Chrome");
		mnBrowser5.addActionListener(this);
		mnBrowser5.setActionCommand("Browser5");

		// ----------------


		JMenu mainLook_Feel = new JMenu("Look & Feel");
		menuBar1.add(mainLook_Feel);

		JMenuItem mnLook_Feel_Windows = new JMenuItem("Windows");
		JMenuItem mnLook_Feel_Motif = new JMenuItem("Motif");
		JMenuItem mnLook_Feel_Metal = new JMenuItem("Metal");
		JMenuItem mnLook_Feel_Nimbus = new JMenuItem("Nimbus");

		mainLook_Feel.add(mnLook_Feel_Windows);
		mainLook_Feel.add(mnLook_Feel_Metal);
		mainLook_Feel.add(mnLook_Feel_Motif);
		mainLook_Feel.add(mnLook_Feel_Nimbus);

		mnLook_Feel_Windows.addActionListener(this);
		mnLook_Feel_Motif.addActionListener(this);
		mnLook_Feel_Metal.addActionListener(this);
		mnLook_Feel_Nimbus.addActionListener(this);

		mnLook_Feel_Windows.setActionCommand("Windows");
		mnLook_Feel_Motif.setActionCommand("Motif");
		mnLook_Feel_Metal.setActionCommand("Metal");
		mnLook_Feel_Nimbus.setActionCommand("Nimbus");

		JMenu mainOptions = new JMenu("Options");
		menuBar1.add(mainOptions);
		JMenuItem mnOption = new JMenuItem("Properties");
		mainOptions.add(mnOption);
		mnOption.addActionListener(this);
		mnOption.setActionCommand("showOptions");

		JMenuItem mnProgInfo = new JMenuItem("Program-Info");
		mainOptions.add(mnProgInfo);
		mnProgInfo.addActionListener(this);
		mnProgInfo.setActionCommand("ProgInfo");

		this.setJMenuBar(menuBar1);
		Basis.setMenueFont(menuBar1, true, this.fontsize); // leider doppelt vorhanden

	} // setMenus

	private void setToolBars() {
		JToolBar toolBar = new JToolBar();

		toolBar.add(bnOpen);
		bnOpen.addActionListener(this);
		bnOpen.setActionCommand("OpenFile");

		bnNew.addActionListener(this);
		bnNew.setActionCommand("NewFile");
		toolBar.add(bnNew);

		bnSave.addActionListener(this);
		bnSave.setActionCommand("SaveFile");
		toolBar.add(bnSave);

		bnSaveAll.addActionListener(this);
		bnSaveAll.setActionCommand("SaveAllFiles");
		toolBar.add(bnSaveAll);

		toolBar.addSeparator(new Dimension(20, 10));

		
		toolBar.add(bnSafari);
		toolBar.add(bnFirefox);
		toolBar.add(bnOpera);
		toolBar.add(bnChrome);

		bnSafari.addActionListener(this);
		bnFirefox.addActionListener(this);
		bnOpera.addActionListener(this);
		bnChrome.addActionListener(this);

		bnSafari.setActionCommand("Safari");
		bnFirefox.setActionCommand("Firefox");
		bnOpera.setActionCommand("Opera");
		bnChrome.setActionCommand("Chrome");

		bnSafari.setForeground(Color.red);
		bnFirefox.setForeground(Color.red);
		bnOpera.setForeground(Color.red);
		bnChrome.setForeground(Color.red);

		chkRunTab0.setMargin(new Insets(5,50,5,5));
		chkRunTab0.addActionListener(this);
		chkRunTab0.setActionCommand("chkRunTab0");
		toolBar.add(chkRunTab0);
				
		
		setFontsize(fontsize);

		this.getContentPane().add(toolBar, BorderLayout.NORTH);

		String os = System.getProperty("os.name"); // os.arch amd64 ia64 x86 Windows 10
		if (isWindows) {
			bnSafari.setEnabled(false);
			bnSafari.setForeground(Color.GRAY);
		}
		System.out.println(os);
	} // setToolBars

	public void actionPerformed(ActionEvent e) {
		String cmd = e.getActionCommand();
		if (cmd.equals("NewFile")) {
			mnNew_Click();
		}
		if (cmd.equals("OpenFile")) {
			mnOpen_Click();
		}
		if (cmd.equals("SaveFile")) {
			mnSave_Click();
		}
		if (cmd.equals("SaveAsFile")) {
			mnSaveAs_Click();
		}
		if (cmd.equals("SaveAllFiles")) {
			mnSaveAllFiles_Click();
		}

		if (cmd.equals("SaveAllFiles")) {
			mnSaveAllFiles_Click();
		}

		if (cmd.equals("Calc")) {
			try {
				ProcessBuilder proc = new ProcessBuilder("calc.exe");
				proc.start();
			} catch (IOException e1) {
			}
		}
		if (cmd.equals("Dos")) {
			try {
			 if (isWindows) {
				ProcessBuilder proc = new ProcessBuilder("cmd.exe");
				proc.start();
	        	  }
        		  else {
                		  ProcessBuilder proc = new ProcessBuilder("bash");
	                  proc.start();
        		  }	
			} catch (IOException e1) {
			}
		}
		if (cmd.equals("Notepad")) {
			mnNotepad_Click();
		}

		if (cmd.equals("Explorer")) {
			try {
				ProcessBuilder proc = new ProcessBuilder("explorer.exe");
				proc.start();
			} catch (IOException e1) {
			}
		}

		// ----------------------------------
		if (cmd.equals("Cut")) {
			mnCut_Click();
		}
		if (cmd.equals("Copy")) {
			mnCopy_Click();
		}
		if (cmd.equals("Paste")) {
			mnPaste_Click();
		}
		if (cmd.equals("SelectAll")) {
			mnSelectAll_Click();
		}

		// View
		if (cmd.equals("Format")) {
			mnFormat_Click();
		}
		if (cmd.equals("CloseTab")) {
			mnCloseTab_Click();
		}
		
		if (cmd.equals("Tab2Left")) {
			mnTab2Left_Click();
		}
		if (cmd.equals("Tab2Right")) {
			mnTab2Right_Click();
		}
		
		
		if (cmd.equals("Darkmode")) {
			mnDarkmode_Click();
		}
		if (cmd.equals("Lightmode")) {
			mnLightmode_Click();
		}

		if (cmd.equals("StandardBrowser")) {
			execute("", true);
		}
		if (cmd.equals("Safari")) {
			Safari_Click();
		}
		if (cmd.equals("Firefox")) {
			Firefox_Click();
		}
		if (cmd.equals("Opera")) {
			Opera_Click();
		}
		if (cmd.equals("Chrome")) {
			Chrome_Click();
		}
		if (cmd.equals("Browser5")) {
			Browser5_Click();
		}
		if (cmd.equals("Browser6")) {
			Browser6_Click();
		}

		// ---------------------------------

	

		if (cmd.equals("Windows")) {
			try {
				UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
				SwingUtilities.updateComponentTreeUI(this.getContentPane()); // alles neuzeichnen
				return;
			} catch (Exception elook) {
			}
		}
		if (cmd.equals("Motif")) {
			setMotif();
		}
		if (cmd.equals("Metal")) {
			try {
				UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
				SwingUtilities.updateComponentTreeUI(this.getContentPane()); // alles neuzeichnen
				return;
			} catch (Exception elook) {
			}
		}
		if (cmd.equals("Nimbus")) {
			try {
				UIManager.setLookAndFeel("com.sun.java.swing.plaf.nimbus.NimbusLookAndFeel");
				SwingUtilities.updateComponentTreeUI(this.getContentPane()); // alles neuzeichnen
				return;
			} catch (Exception elook) {
			}
		}

		if (cmd.equals("showOptions")) {
			showOptions();
		}

		if (cmd.equals("ProgInfo")) {
			showProgInfo();
		}

		if (cmd.equals("fontsize")) {
			setFontsize((MyJCheckBoxMenuItem) e.getSource());
		}

	} // actionPerformed

	private void setFontsize(MyJCheckBoxMenuItem mn) {
		this.fontsize = mn.tag;
		Basis.setMenueFont(menuBar1, true, this.fontsize);
		setFontsize(this.fontsize);
		singvar.writeProperties();

	}

	private void setFontsize(int fontsize) {
		singvar.setFontsize(this.fontsize);
		for (int j = 0; j < mainFont.getItemCount(); j++) {
			// Abfrage auf Separator, sonst Absturz
			if (mainFont.getItem(j) instanceof MyJCheckBoxMenuItem) {
				MyJCheckBoxMenuItem mn2 = (MyJCheckBoxMenuItem) mainFont.getItem(j);
				if (mn2.tag == this.fontsize) {
					mn2.setSelected(true);
				} else {
					mn2.setSelected(false);
				}
			}
		}
		// Clientfenster
	      for (int j=0; j<tabbedpane.getTabCount(); j++) {
	          ChildForm child = (ChildForm) tabbedpane.getComponentAt(j);  // getTabComponentAt(j);
	          child.setFontSize(this.fontsize);
	      }		
	      
		
		tabbedpane.setFont(new Font("Arial", Font.PLAIN, fontsize));

		bnOpen.setFont(new Font("Arial", Font.BOLD, fontsize));
		bnNew.setFont(new Font("Arial", Font.BOLD, fontsize));
		bnSave.setFont(new Font("Arial", Font.BOLD, fontsize));
		bnSaveAll.setFont(new Font("Arial", Font.BOLD, fontsize));

		bnSafari.setFont(new Font("Arial", Font.BOLD, fontsize));
		bnFirefox.setFont(new Font("Arial", Font.BOLD, fontsize));
		bnOpera.setFont(new Font("Arial", Font.BOLD, fontsize));
		bnChrome.setFont(new Font("Arial", Font.BOLD, fontsize));
		chkRunTab0.setFont(new Font("Arial", Font.BOLD, fontsize));
	}

	
	private void execute(String sBrowser, boolean bStandard) {
		// System.out.println(sBrowser);
		if (tabbedpane.getTabCount()>0) {
			ChildForm child=null;
			if (chkRunTab0.isSelected()) {
				child = (ChildForm) tabbedpane.getComponentAt(0);  // getTabComponentAt(j);
			}
			else {
				child = getActiceForm();
			}
			String filename = "";
			if (!child.getFilename().equals(SingVar.C_NONAME)) {
				child.saveFile();
				filename = child.getFilename();
				String ext = Basis.getFileExt(filename).toLowerCase();
				if (ext.equals(".css")) {
					// suche html-child

					boolean gefunden=false;
					String[] exts = {"xhtml", "html", "php", "htm", "jsp" };
					for(String extloop : exts) {
						String filenameXhtml = Basis.changeFileExt(filename, extloop);
						System.out.println(filenameXhtml);
						for (int j=0; j<tabbedpane.getTabCount(); j++) {
					          ChildForm child2 = (ChildForm) tabbedpane.getComponentAt(j);  // getTabComponentAt(j);
					          if (child2.getFilename().equals(filename)) {
									child2.saveFile();
									filename = filenameXhtml;
									gefunden=true;
									break;
								}
					      }  // foreach (TabPage page in tabControl1.TabPages)
						if (gefunden) {
							break;
						}
					}
				} // if (ext.equals(".css")) {
				
				String param = filename;
				System.out.println("param1: " + param);
				if (ext.equals(".php") || ext.equals(".xhtml") || ext.equals(".htm") || ext.equals(".html") || ext.equals(".jsp")) {
					int posi = filename.indexOf("htdocs\\");
					//System.out.println("posi: " + posi);
					if (posi >= 0) {
						if (sBrowser.toLowerCase().indexOf("firefox.exe") >= 0)
							param = "localhost:" + singvar.getPhpPort() + "/"
									+ filename.substring(posi + 7).replace("\\", "/");
						else
							param = "127.0.0.1:" + singvar.getPhpPort() + "/"
									+ filename.substring(posi + 7).replace("\\", "/");
						System.out.println("param2: " + param);
					}
				}
				ProcessBuilder proc;
		          try {
		        	  if (isWindows) {
		                  if (bStandard) {
		                      proc = new ProcessBuilder("\"" +param+"\"", ""  );
		                      proc.start();
		                  }
		                  else    {
		                    proc = new ProcessBuilder(  sBrowser , "\"" +param+"\""  );
		                    proc.start();
		                  }              
		        	  }
		        	  else {
		        		  // apple linux
		        		  if (chkRunTab0.isSelected()) {
		        			  int posi = filename.indexOf("htdocs/");
		        			  param = "localhost/"+ filename.substring(posi + 7);
		        			  
		        			  StringSelection selection = new StringSelection(param);
		        			  Clipboard clipboard = Toolkit.getDefaultToolkit().getSystemClipboard();
		        			  clipboard.setContents(selection, selection);
		        			  
		                      Process process = Runtime.getRuntime().exec(param);
		                      process = Runtime.getRuntime().exec("open " +param); 
		        		  }
		        		  else {
		                      Process process = Runtime.getRuntime().exec("open " +param); 
		        		  }
		        	  }
		          }
		          catch (IOException e1) {
		        	  Basis.ErrorBox(e1.toString(),"Error to call the browser\n"+sBrowser);
		          }  
			} // if (!child.getFilename().equals(SingVar.C_NONAME)) {

		}  // if tabCount>0
	} // execute
	
	

	private void Safari_Click() {
		if (singvar.getSafari().length()>0)
			   execute(singvar.getSafari(),false);
		   else
			   execute("",false);
		}
	   
	   private void Firefox_Click() {
		   	if (isWindows) {
			      String sBrowser =    singvar.getFirefox();
			      if (sBrowser.length()==0) {
					   Basis.MessageBox("Der Firefox-Browser ist nicht gesetzt","Hinweis");		   
				   }
				   else {
					   execute(sBrowser,false);
				   }
		   	}
		   	else {
				   execute("",false);
		   }
	   }
	   
	   private void Opera_Click() {
		   if (isWindows) {
		   String sBrowser =    singvar.getOpera();
		   if (sBrowser.length()==0) {
			   Basis.MessageBox("Der Opera-Browser ist nicht gesetzt","Hinweis");		   
		   }
		   else {
			   execute(sBrowser,false);
		   }
		   }
		   else {
			   execute("",false);
		   }
	   }

	   private void Chrome_Click() {
		   if (isWindows) {
		   String sBrowser =    singvar.getChrome();   
		   if (sBrowser.length()==0) {
			   Basis.MessageBox("Der Chrome-Browser ist nicht gesetzt","Hinweis");		   
		   }
		   else {
			   execute(sBrowser,false);
		   }
		   }
		   else {
			   execute("",false);
		   }
	   }

	private void Browser5_Click() {
		SingVar singvar = SingVar.getInstance();
		if (Basis.FileExists(singvar.getBroswer5()))
			execute(singvar.getBroswer5(), false);
		else
			Basis.MessageBox("Der 5. Browser ist nicht vorhanden", "Hinweis");
	}

	private void Browser6_Click() {
		SingVar singvar = SingVar.getInstance();

		if (Basis.FileExists(singvar.getBroswer6()))
			execute(singvar.getBroswer6(), false);
		else
			Basis.MessageBox("Der 6. Browser ist nicht vorhanden", "Hinweis");
	}

	private void addClientFrame(ChildForm frame) {
		final int w = 550;
		final int h = 400;
		 tabbedpane.addTab(Basis.getFileNameExt(frame.getFilename()),null, frame, frame.getFilename());
		 tabbedpane.setSelectedIndex(0);
		 //for (int j=0; j<tabbedpane.getTabCount(); j++) {
	}

	// Beispiel zum Oeffnen EINER Datei
	private void mnNew_Click() {
		FRadio3 frame = new FRadio3(this);
		if (frame.bResult) {
			String filename = SaveNewFile(frame.iNeuerDateiTyp);
			if (filename.equals(""))
				return;

			String   filenameCSS = Basis.changeFileExt(filename, "css");

			switch (frame.iNeuerDateiTyp) {
			case FRadio3.C_HTMLCSS:
				SingVar.SaveCSS_Html_BasicXHTML(filename, filenameCSS);
				HTMLForm childForm1a = new HTMLForm(filename); // SingVar.C_NONAME);
				addClientFrame(childForm1a);

				CSSForm childForm1b = new CSSForm(filenameCSS);
				addClientFrame(childForm1b);
				break;

			case FRadio3.C_PHPHTML:
				SingVar.SaveCSS_Html_BasicPhpCSS(filename, filenameCSS);
				HTMLForm childForm2a = new HTMLForm(filename); // SingVar.C_NONAME);
				addClientFrame(childForm2a);

				CSSForm childForm2b = new CSSForm(filenameCSS);
				addClientFrame(childForm2b);
				break;

			case FRadio3.C_PHPPUR:
				HTMLForm childForm3 = new HTMLForm(filename); // SingVar.C_NONAME);
				addClientFrame(childForm3);
				// childForm3.Text = "Fenster " + childFormNumber++;
				// childForm3.Show();

				break;

			case FRadio3.C_JAVASCRIPT:
				SingVar.SaveJavascript(filename);
				HTMLForm childFormJs = new HTMLForm(filename); // SingVar.C_NONAME);
				addClientFrame(childFormJs);
				break;
			default:
				Basis.MessageBox("Fehler in Modul NewClick, Falsche Dateiauswahl", "Hinweis");
				break;
			}
		}
	} // mnNew

	private String SaveNewFile(int filetyp) {
		String DefaultExt = "";
		JFileChooser jfc;
		jfc = new JFileChooser();
		jfc.setMultiSelectionEnabled(false);
		jfc.setCurrentDirectory(new File((String) System.getProperties().get("user.dir")));
		jfc.setCurrentDirectory(new File("D:\\cdaten\\html"));

		switch (filetyp) {
		case FRadio3.C_HTMLCSS:
			jfc.addChoosableFileFilter(new MyFileFilter(new String[] { "xhtml", "css" }, "HTML-Dateien (*.xhtml;*.css)"));
			jfc.addChoosableFileFilter(new MyFileFilter("xhtml", "HTML-Dateien (*.xhtml)"));
			jfc.addChoosableFileFilter(new MyFileFilter(new String[] { "html", "htm" }, "HTML-Dateien (*.html;*.htm)"));
			jfc.addChoosableFileFilter(
					new MyFileFilter(new String[] { "xhtml", "html", "htm" }, "HTML-Dateien (*.xhtml;*.html;*.htm)"));
			jfc.addChoosableFileFilter(new MyFileFilter("css", "CSS-Dateien (*.css)"));
			jfc.addChoosableFileFilter(new MyFileFilter("php", "PHP-Dateien (*.php)"));
			DefaultExt = ".xhtml";
			break;

            case FRadio3.C_PHPHTML:
            case FRadio3.C_PHPPUR:
			jfc.addChoosableFileFilter(new MyFileFilter("php", "PHP-Dateien (*.php)"));
			jfc.addChoosableFileFilter(new MyFileFilter("xhtml", "HTML-Dateien (*.xhtml)"));
			jfc.addChoosableFileFilter(new MyFileFilter(new String[] { "html", "htm" }, "HTML-Dateien (*.html;*.htm)"));
			jfc.addChoosableFileFilter(
					new MyFileFilter(new String[] { "xhtml", "html", "htm" }, "HTML-Dateien (*.xhtml;*.html;*.htm)"));
			jfc.addChoosableFileFilter(new MyFileFilter("css", "CSS-Dateien (*.css)"));
			DefaultExt = ".php";
			break;

		case FRadio3.C_JAVASCRIPT:
			jfc.addChoosableFileFilter(new MyFileFilter("js", "Js-Dateien (*js)"));
			DefaultExt = ".js";
			break;

		default:
			Basis.MessageBox("Fehler in Modul SaveNewFile, Falscher Dateityp", "Hinweis");
			break;
		}

		if (JFileChooser.APPROVE_OPTION == jfc.showSaveDialog(this)) {
			String sFilename = jfc.getSelectedFile().getPath();
			if (sFilename.indexOf(".") == -1) {
				sFilename += DefaultExt;
			}

			return sFilename;
		} else
			return "";
	}

	private void mnOpen_Click() {
		JFileChooser jFileChooser1;
		File[] files; // Array fr

		jFileChooser1 = new JFileChooser();
		jFileChooser1.setMultiSelectionEnabled(true);

		String path = singvar.getStartDir();
		jFileChooser1.setCurrentDirectory(new File((String) System.getProperties().get("user.dir")));
		jFileChooser1.setCurrentDirectory(new File(path));

		jFileChooser1.addChoosableFileFilter(new MyFileFilter("xhtml", "HTML-files (*.xhtml)"));

		jFileChooser1.addChoosableFileFilter(
				new MyFileFilter(new String[] { "html", "htm" }, "HTML-Dateien (*.html;*.htm)"));
		jFileChooser1.addChoosableFileFilter(
				new MyFileFilter(new String[] { "xhtml", "html", "htm" }, "HTML-Dateien (*.xhtml;*.html;*.htm)"));
		jFileChooser1.addChoosableFileFilter(new MyFileFilter("css", "CSS-files (*.css)"));

		jFileChooser1
				.addChoosableFileFilter(new MyFileFilter(new String[] { "xml", "xsl" }, "XML-Dateien (*.xml;*.xsl)"));

		jFileChooser1.addChoosableFileFilter(new MyFileFilter("php", "PHP-files (*.php)"));
		jFileChooser1.addChoosableFileFilter(new MyFileFilter("*", "All files (*.*)|*.*"));

		jFileChooser1.setPreferredSize(new Dimension(1000, 600));
		jFileChooser1.setDialogTitle("Open file(s)");
		// Okay gedrckt ?
		if (JFileChooser.APPROVE_OPTION == jFileChooser1.showOpenDialog(this)) {
			files = jFileChooser1.getSelectedFiles();
			for (int i = 0; i < files.length; i++) {
				checkFileopen(files[i].getPath());
			}
		}
	} // mnOpen

	private void checkFileopen(String filename) {
	//	JInternalFrame[] ff = _desktopPane.getAllFrames();

		boolean bIsOpen = false;
		for (int j=0; j<tabbedpane.getTabCount(); j++) {
	          ChildForm child = (ChildForm) tabbedpane.getComponentAt(j);  // getTabComponentAt(j);
	          String s = ((ChildForm) child).getFilename();
				if (filename.equals(s)) {
					tabbedpane.setSelectedIndex(j);
					//_desktopPane.setSelectedFrame(childForm);
					bIsOpen = true;
					break;
				}
	      }
		

		if (!bIsOpen) {
			OpenFile(filename);
			// SingVar instance = SingVar.getInstance();
			// instance.deleteFile(sFilename);
		}
	}

	private void OpenFile(String filename) {
		String sExt = Basis.getFileExt(filename).toLowerCase();
		try {
			singvar.setStartDir(Basis.getPath(filename));
			//System.out.println("**************** openPath: " + Basis.getPath(filename));
		} catch (Exception e) {
			System.out.println("exception " + e.toString());
		}
		singvar.writeProperties();
		// getFilenameExt(sFilename).ToLower();
		if (sExt.equals(".css")) {
			CSSForm frame = new CSSForm(filename);
			addClientFrame(frame);
			frame.setFontSize(this.fontsize);
			frame.format();
		} else {
			HTMLForm frame = new HTMLForm(filename);
			addClientFrame(frame);
			frame.setFontSize(this.fontsize);
			frame.format();
		}
	}

	private ChildForm getActiceForm() {
		if (tabbedpane.getTabCount()>0) {
			int j = tabbedpane.getSelectedIndex();
	          ChildForm child = (ChildForm) tabbedpane.getComponentAt(j);  // getTabComponentAt(j);
	          return  child;
		}
		else {
			return null;
		}
	}

	private void mnNotepad_Click() {
		String sFilename = "";
		ChildForm child = getActiceForm();
		if (child != null) {
			if (!child.getFilename().equals(SingVar.C_NONAME)) {
				sFilename = child.getFilename();
			}
		}
		try {
			ProcessBuilder proc = new ProcessBuilder("notepad.exe", "\"" + sFilename + "\"");
			proc.start();
		} catch (IOException e1) {
		}
	} // MnNotepad_Click

	private void mnSaveAllFiles_Click() {
		for (int j=0; j<tabbedpane.getTabCount(); j++) {
	          ChildForm child = (ChildForm) tabbedpane.getComponentAt(j);  // getTabComponentAt(j);
				if (child.getFilename().equals(SingVar.C_NONAME))
					mnSaveAs_Click();
				else
					child.saveFile();
	      }		
	}

	private void mnSave_Click() {
		ChildForm child = getActiceForm();
		if (child != null) {
			if (child.getFilename().equals(SingVar.C_NONAME))
				mnSaveAs_Click();
			else
				child.saveFile();
		}
	}

	private void mnSaveAs_Click() {
		JFileChooser jFileChooser1;
		ChildForm child = getActiceForm();
		if (child != null) {
			String filenameOri = child.getFilename();
			String extOri = Basis.getFileExt(child.getFilename()).toLowerCase();
			jFileChooser1 = new JFileChooser();
			jFileChooser1.setMultiSelectionEnabled(false);
			jFileChooser1.setCurrentDirectory(new File((String) System.getProperties().get("user.dir")));
			jFileChooser1.setCurrentDirectory(new File("D:\\cdaten\\html"));
			jFileChooser1.addChoosableFileFilter(new MyFileFilter("xhtml", "HTML-Dateien (*.xhtml)"));
			jFileChooser1.addChoosableFileFilter(
					new MyFileFilter(new String[] { "html", "htm" }, "HTML-Dateien (*.html;*.htm)"));
			jFileChooser1.addChoosableFileFilter(
					new MyFileFilter(new String[] { "xhtml", "html", "htm" }, "HTML-Dateien (*.xhtml;*.html;*.htm)"));
			jFileChooser1.addChoosableFileFilter(new MyFileFilter("css", "CSS-Dateien (*.css)"));
			jFileChooser1.addChoosableFileFilter(
					new MyFileFilter(new String[] { "xml", "xsl" }, "XML-Dateien (*.xml;*.xsl)"));
			jFileChooser1.addChoosableFileFilter(new MyFileFilter("php", "PHP-Dateien (*.php)"));
			jFileChooser1.addChoosableFileFilter(new MyFileFilter("*", "Alle Dateien (*.*)|*.*"));
			jFileChooser1.setPreferredSize(new Dimension(1000, 600));
			jFileChooser1.setDialogTitle("Datei speichern");
			// Okay gedrckt ?
			if (JFileChooser.APPROVE_OPTION == jFileChooser1.showSaveDialog(this)) {
				String filenameNew = jFileChooser1.getSelectedFile().getPath();
				String extNew = Basis.getFileExt(filenameNew).toLowerCase();
				if (extNew.length() == 0) {
					filenameNew += extOri;
				}
				child.saveAs(filenameNew);
				// suche test1.css
				String filenameCssOri = Basis.changeFileExt(filenameOri, "css");
				String filenameCssNew = Basis.changeFileExt(filenameNew, "css");
				System.out.println("cssOri:" + filenameCssOri);
				System.out.println("cssnew:" + filenameCssNew);
				boolean gefunden = false;
				for (int j=0; j<tabbedpane.getTabCount(); j++) {
			          ChildForm child2 = (ChildForm) tabbedpane.getComponentAt(j);  // getTabComponentAt(j);
			          if (child2.getFilename().equals(filenameCssOri)) {
							System.out.println("   -:" + child2.getFilename());
							child2.saveAs(filenameCssNew);
							gefunden = true;
						}
				} // foreach (TabPage page in tabControl1.TabPages)

				if (!gefunden && Basis.FileExists(filenameCssOri)) {
					Basis.filecopy(filenameCssOri, filenameCssNew);
				}

			}

		}

	} // mnSaveAs

	private void mnCut_Click() {
		ChildForm child = getActiceForm();
		if (child != null) {
			child.cut();
		}
	}

	private void mnCopy_Click() {
		ChildForm child = getActiceForm();
		if (child != null) {
			child.copy();
		}
	}

	private void mnPaste_Click() {
		ChildForm child = getActiceForm();
		if (child != null) {
			child.paste();
		}
	}

	private void mnSelectAll_Click() {
		ChildForm child = getActiceForm();
		if (child != null) {
			child.selectAll();
		}
	}

	private void mnFormat_Click() {
		ChildForm child = getActiceForm();
		if (child != null) {
			child.format();
		}
	}
	
	private void mnCloseTab_Click() {
		if (tabbedpane.getTabCount()>0) {
			tabbedpane.remove( tabbedpane.getSelectedIndex() );
		}
	}	
	
	private void mnTab2Left_Click() {
		if (tabbedpane.getTabCount()>1) {
			int i=tabbedpane.getSelectedIndex();
			if (i>0) {
				ChildForm child = (ChildForm)  tabbedpane.getComponentAt(i); 
				tabbedpane.remove( i );
			//	tabbedpane.insertTab(Basis.getFileNameExt(child.getFilename()),null, child, child.getFilename(), i-1);
			}
		}
	}	
	private void mnTab2Right_Click() {
		if (tabbedpane.getTabCount()>1) {
			tabbedpane.remove( tabbedpane.getSelectedIndex() );
		}
	}	

	private void mnDarkmode_Click() {
		setMotif();  // Nimbus geht nicht
		for (int j=0; j<tabbedpane.getTabCount(); j++) {
	          ChildForm child = (ChildForm) tabbedpane.getComponentAt(j);  // getTabComponentAt(j);
	          child.darkmode();
	      }		
	}

	private void mnLightmode_Click() {
		for (int j=0; j<tabbedpane.getTabCount(); j++) {
	          ChildForm child = (ChildForm) tabbedpane.getComponentAt(j);  // getTabComponentAt(j);
	          child.lightmode();
	      }		
	}

	private void setMotif() {
		try {
			UIManager.setLookAndFeel("com.sun.java.swing.plaf.motif.MotifLookAndFeel");
			SwingUtilities.updateComponentTreeUI(this.getContentPane()); // alles neuzeichnen
			return;
		} catch (Exception elook) {
		}
	}
	
	// wird aufgerufen beim Schliessen des Hauptfensters
	private void mnClose_Click() {
		this.dispose(); // System.exit(0);
	}


	private void showOptions() {
		FShowOptions form = new FShowOptions(this);
		if (form.bResult) {
			// alle Eigenschaften neu setzen, in allen Clients
			for (int j=0; j<tabbedpane.getTabCount(); j++) {
		          ChildForm child = (ChildForm) tabbedpane.getComponentAt(j);  // getTabComponentAt(j);
		          child.updateOptionSession();
		      }		
		}
	} // showOptions

	private void showProgInfo() {
		FProgInfo form = new FProgInfo(this);
	} // showOptions

	// Hauptprogramm
	static public void main(String[] args) {
		IHTMLRtfTab frame = new IHTMLRtfTab();
		frame.setVisible(true);
	}

}
