import java.util.ArrayList;

public class SplitColorTextPane {
	
	 public enum ColorTyp {
         html,
         text,
         space,
         specialchars,
         comments
     }

     public class ColorString {
         public StringBuilder sb = new StringBuilder();
         public ColorTyp colortyp = ColorTyp.text;
     }
     public class StringList {
         public int anzTabs = 0;
         public ArrayList<ColorString> colorstrings = new ArrayList<ColorString>();
     }

     class LineAbschnitt2 {
         public boolean isFertig = false;
         public boolean setComment = false;
         public ColorString colorstring = null;
         public String line = "";

         public LineAbschnitt2(String line) {
             this.line = line;
         }
         public LineAbschnitt2(ColorString colorstring) {
             this.colorstring = colorstring;
         }
     }

     // PHP oder Javascript
     private String[] highlightItems = new String[] {
         "$_GET",
         "alert",
         "append",
         "array",
         "as",
         "bin2hex",
         "case",
         "charAt",
         "charCodeAt",
         "class",
         "concat",
         "console",
         "count",
         "display ",
         "do",
         "document",
         "double",
         "Double",
         "echo",
         "element",
         "else",
         "explode",
         "fetch_array",
         "float",
         "for",
         "format",
         "fromCharCode",
         "function",
         "connect_error",
         "foreach",

         "getElementById",
         "getParameterValues",
         "if",
         "import",
         "include",
         "indexOf",
         "innerHTML",
         "int",
         "Integer",
         "intval",
         "is_numeric",
         "isNaN",
         "isset",
         "java",
         "json_encode",
         "lang",
         "lastIndexOf",
         "length",
         "length",
         "let",
         "localeCompare",
         "localhost",
         "log",
         "ltrim",
         "match",
         "mysqli",
         "NaN",
         "new",
         "NumberFormatException",
         "onreadystatechange",
         "open",
         "out",
         "page",
         "parseDouble",
         "parseFloat",
         "parseInt",
         "preg_match",
         "print",
         "println",
         "push",
         "query",
         "readyState",
         "reflect",
         "RegExp",
         "replace",
         "responseText",
         "request",
         "return",
         "root",
         "rtrim",
         "search",
         "send",
         "SimpleDateFormat",
         "slice",
         "split",
         "str_split",
         "strict",
         "String",
         "StringBuilder",
         "strlen",
         "strtok",
         "strtoupper",
         "style",
         "substr",
         "substring",
         "this",
         "toExponential",
         "toFixed",
         "toLocaleLowerCase",
         "toLocaleUpperCase",
         "toLowerCase",
         "toPrecision",
         "toString",
         "toUpperCase",
         "trim",
         "trim",
         "use",
         "util",
         "valueOf",
         "var",
         "value",
         "while",
         "window",

         "catch",
         "null",
         "getParameter",
         "boolean",
         "Boolean",
         "double",
         "Double",
         "true",
         "false",
         "intValue",
         "FileInputStream",
         "FileOutputStream",
         "DataInputStream",
         "DataOutputStream",
         "PrintStream",
         "close",
         "IOException",
         "Exception",
         "FileNotFoundException",
         "finally",
         "Connection",
         "Statement",
         "ResultSet",
         "DriverManager",
         "getConnection",
         "createStatement",
         "executeQuery",
         "executeUpdate",
         "try",
         "ArrayList",
         "Class",
         "forName",
         "next",
         "getString",
         "add",

         "XMLHttpRequest"
     };


     private String editText = null;
     private String[] lines = null;

     public ArrayList<StringList> gesamtliste = new ArrayList<StringList>();

     private double tabsize = 2;



     private ColorTyp checkColorTyp(boolean html, char ch) {
         try {
             int code = ch;
        	 //System.out.println("code: "+code);
             if ((code >= 65 && code <= 90) || (code >= 97 && code <= 122) || (code >= 48 && code <= 57) ||
                 (code == 220) || (code == 196) || (code == 214) || (code == 252) || (code == 228) || (code == 246) || (code == 223)) {
                 if (html)
                     return ColorTyp.html;
                 else
                     return ColorTyp.text;
             }
             else if (code == 32) {
                 return ColorTyp.space;
             }

             else if ((code >= 33 && code <= 47) || (code >= 58 && code <= 64) || (code >= 91 && code <= 96) || (code >= 123 && code <= 126))
                 return ColorTyp.specialchars;
             else {
                 Basis.ErrorBox("Fehlerhafte Abfrage in checkColorTyp: char: " + ch, "Info");
                 return ColorTyp.text;
             }
         }
         catch (Exception e) {
             Basis.ErrorBox("Exception im checkColorTyp\r\n" + e.toString(), "Fehler");
             return ColorTyp.text;
         }
     }

     private ColorTyp checkColorTypScript(char ch) {
         try {
             int code = ch;
             if ((code >= 65 && code <= 90) || (code >= 97 && code <= 122) || (code >= 48 && code <= 57) || (code == 95) ||
                 (code == 220) || (code == 196) || (code == 214) || (code == 252) || (code == 228) || (code == 246) || (code == 223)) {
                 return ColorTyp.text;
             }
             else if (code == 32) {
                 return ColorTyp.space;
             }
             else {
                 return ColorTyp.specialchars;
             }
         }
         catch (Exception e) {
             Basis.ErrorBox("Exception im checkColorTypScript\r\n" + e.toString(), "Fehler");
             return ColorTyp.text;
         }
     }
     


     public void splitText(String text) {
         this.editText = text.replace(Konst.C_TAB, " ");
         String[] splitStrings = { "\r\n" };
         lines = editText.split(Basis.getlineSeparator());

         try {
             gesamtliste.clear();
             // private List<StringList> liste = new List<StringList>();


             boolean html = false;
             boolean scriptBlock = false;
             boolean scriptComment2 = false;
             StringList stringListLine = null;  // 1x pro Zeile
             ColorString colorstring = null;  // mehrfach pro Zeile
                                              // <?xml version="1.0" encoding="UTF-8" ?>


             for (int i=0; i<lines.length; i++) {
            	 String line2 = lines[i];
                 String line3 = line2.trim();
                 stringListLine = new StringList();
                 if (line2.startsWith("      ",0))
                     stringListLine.anzTabs = 6;
                 else if (line2.startsWith("     ",0))
                     stringListLine.anzTabs = 5;
                 else if (line2.startsWith("    "))
                     stringListLine.anzTabs = 4;
                 else if (line2.startsWith("   "))
                     stringListLine.anzTabs = 3;
                 else if (line2.startsWith("  "))
                     stringListLine.anzTabs = 2;
                 else if (line2.startsWith(" "))
                     stringListLine.anzTabs = 1;

                 gesamtliste.add(stringListLine);
                 colorstring = null;  // noch nichts passiert in der aktuellen Zeile
                 html = false;
                 int posi = 0;
                 ColorString colorstringCommentSlashSlash = null;
                 ColorString colorstringCommentBlock = null;  // 

                if (scriptBlock) {  				// checkColorTypScript
                	 ArrayList<LineAbschnitt2> lineAbschnittListe = new ArrayList<LineAbschnitt2>();

                     lineAbschnittListe.add(new LineAbschnitt2(line3));
                     while (lineAbschnittListe.size() > 0) {
                         LineAbschnitt2 abschnitt = lineAbschnittListe.get(0);
                         lineAbschnittListe.remove(0);
                         if (abschnitt.isFertig) {
                             stringListLine.colorstrings.add(abschnitt.colorstring);
                             if (abschnitt.setComment) {
                                 //    $w=12;  /*    
                                 scriptComment2 = true;
                                 colorstringCommentBlock = abschnitt.colorstring;  // 1. Teil  /*    ....
                             }
                             continue;
                         }


                         String lineLoop = abschnitt.line;

                         if (scriptComment2) {
                             // suche */
                             posi = lineLoop.indexOf("*/");
                             if (posi >= 0) {
                                 // ende des Kommentars?         */  $w=12;   /*    ddddd  */
                                 scriptComment2 = false;
                                 // ende Kommentar-Block in die Zeilenabschnittsliste
                                 String linex = lineLoop.substring(0, posi + 2);  // 2=*/
                                 ColorString colorstring22 = new ColorString();
                                 colorstring22.colortyp = ColorTyp.comments;
                                 colorstring22.sb.append(linex);
                                 stringListLine.colorstrings.add(colorstring22);
                                 // den Rest in die While-Liste
                                 linex = lineLoop.substring(posi + 2);
                                 if (linex.trim().length() > 0) {
                                     LineAbschnitt2 abschnitt3 = new LineAbschnitt2(linex);
                                     lineAbschnittListe.add(0, abschnitt3);
                                 }
                                 continue;
                             }
                             else {
                                 // komplette Zeile als Kommentar!
                                 if (colorstringCommentBlock == null) {
                                     colorstringCommentBlock = new ColorString();
                                     colorstringCommentBlock.colortyp = ColorTyp.comments;
                                     stringListLine.colorstrings.add(colorstringCommentBlock);
                                 }
                                 colorstringCommentBlock.sb.append(lineLoop);
                                 continue;
                             }
                         }
                         else {
                             // if  (!scriptComment2) {
                             posi = lineLoop.indexOf("//");            //  suche   //  und /*
                             int posi2a = lineLoop.indexOf("/*");
                             if (posi >= 0 && posi2a >= 0) {
                                 if (posi > posi2a) {
                                     posi = -1;
                                 }
                                 else {
                                     posi2a = -1;
                                 }
                             }

                             if (posi >= 0) {
                                 String str_comment = lineLoop.substring(posi);
                                 lineLoop = lineLoop.substring(0, posi);
                                 colorstringCommentSlashSlash = new ColorString();
                                 // teste, welche Gruppe
                                 colorstringCommentSlashSlash.colortyp = ColorTyp.comments;
                                 colorstringCommentSlashSlash.sb.append(str_comment);
                             }

                             // kein scriptComment2
                             posi = lineLoop.indexOf("/*");
                             if (posi >= 0) {
                                 // Check, in aktuelle Zeile zu Ende?                              
                                 int posi2 = lineLoop.indexOf("*/");
                                 if (posi2 >= 0) {
                                     if (posi2 > posi) {
                                         //  a) /*     */      b) int a=1  /*    */    c)  /*  */  a=1     d) a=1; /*   */  b=1;
                                         // umgekehrte Reihenfolge

                                         // text nach den Klammern
                                         String linex = lineLoop.substring(posi2 + 2);
                                         if (linex.trim().length() > 0) {
                                             LineAbschnitt2 abschnitt3 = new LineAbschnitt2(linex);
                                             lineAbschnittListe.add(0, abschnitt3);
                                         }

                                         // der Klammerbereich
                                         linex = lineLoop.substring(posi, posi2 - posi + 2);
                                         ColorString colorStringkl = new ColorString();
                                         colorStringkl.colortyp = ColorTyp.comments;
                                         colorStringkl.sb.append(linex);
                                         LineAbschnitt2 abschnitt5 = new LineAbschnitt2(colorStringkl);
                                         abschnitt5.isFertig = true;
                                         abschnitt5.setComment = false;
                                         lineAbschnittListe.add(0, abschnitt5);

                                         // vor dem Klammerbereich
                                         if (posi > 0) {
                                             linex = lineLoop.substring(0, posi);
                                             if (linex.length() > 0) {
                                                 LineAbschnitt2 abschnitt3 = new LineAbschnitt2(linex);
                                                 lineAbschnittListe.add(0, abschnitt3);
                                             }
                                         }
                                         continue;
                                     }
                                     else {
                                         // Fall: max zwei Abschnitte!   int a=1;  /*       int a=1; in die Liste am Anfang
                                         // Klammerbereich, aktivieren des SetComments
                                         String linex = lineLoop.substring(posi);
                                         ColorString colorStringkl = new ColorString();
                                         colorStringkl.colortyp = ColorTyp.comments;
                                         colorStringkl.sb.append(linex);
                                         LineAbschnitt2 abschnitt5 = new LineAbschnitt2(colorStringkl);
                                         abschnitt5.isFertig = true;
                                         abschnitt5.setComment = true;
                                         lineAbschnittListe.add(0, abschnitt5);

                                         linex = lineLoop.substring(0, posi - 1);
                                         if (linex.length() > 0) {
                                             LineAbschnitt2 abschnitt3 = new LineAbschnitt2(linex);
                                             lineAbschnittListe.add(0, abschnitt3);
                                         }
                                         continue;
                                     }
                                 }
                                 else {
                                     //  /*  fngt an

                                     // Fall: zwei Abschnitte!   int a=1;  /*     int a=1; in die Liste am Anfang
                                     String linex = lineLoop.substring(posi);
                                     ColorString colorStringkl = new ColorString();
                                     colorStringkl.colortyp = ColorTyp.comments;
                                     colorStringkl.sb.append(linex);
                                     LineAbschnitt2 abschnitt5 = new LineAbschnitt2(colorStringkl);
                                     abschnitt5.isFertig = true;
                                     abschnitt5.setComment = true;  // !!!!
                                     lineAbschnittListe.add(0, abschnitt5);

                                     if (posi > 0) {
                                         linex = lineLoop.substring(0, posi - 1);
                                         if (linex.length() > 0) {
                                             LineAbschnitt2 abschnitt3 = new LineAbschnitt2(linex);
                                             lineAbschnittListe.add(0, abschnitt3);
                                         }
                                     }
                                     continue;  // 
                                 }
                             }
                         }

                         for (char ch : lineLoop.toCharArray()) {
                             if (colorstring == null) {
                                 colorstring = new ColorString();
                                 stringListLine.colorstrings.add(colorstring);
                                 // teste, welche Gruppe
                                 colorstring.colortyp = checkColorTypScript(ch);
                                 colorstring.sb.append(ch);
                             }
                             else {
                                 ColorTyp colortyp = checkColorTypScript(ch);
                                 // test, ob die Gruppe identisch ist
                                 if (colorstring.colortyp == colortyp) {
                                     colorstring.sb.append(ch);
                                 }
                                 else {
                                     colorstring = new ColorString();
                                     stringListLine.colorstrings.add(colorstring);
                                     // neue Gruppe
                                     colorstring.colortyp = colortyp;
                                     colorstring.sb.append(ch);
                                 }
                             }

                         }  // foreach (char ch in line) {
                            // nun loop ber alle AbschnittsTexte und check mit den Items der highlight-Liste
                     }  // while lineAbschnittListe.Count>0
                     if (colorstringCommentSlashSlash != null) {
                         stringListLine.colorstrings.add(colorstringCommentSlashSlash);
                     }
                     for (ColorString colorstring2 : stringListLine.colorstrings) {
                         if (colorstring2.colortyp != ColorTyp.comments) {
                             for (String item : highlightItems) {
                                 if (colorstring2.sb.toString().equals(item)) {
                                     colorstring2.colortyp = ColorTyp.html;
                                     break;
                                 }
                             }
                         }
                     }

                     // 
                 }
                 else {
                     for (char ch : line3.toCharArray()) {
                         if (ch == '<') {  // 60<   62>
                             html = true;
                         }
                         else if (ch == '>') {  // 60<   62>
                             html = false;
                         }

                         if (colorstring == null) {
                             colorstring = new ColorString();
                             stringListLine.colorstrings.add(colorstring);
                             // teste, welche Gruppe
                             colorstring.colortyp = checkColorTyp(html, ch);
                             colorstring.sb.append(ch);
                         }
                         else {
                             ColorTyp colortyp = checkColorTyp(html, ch);
                             // test, ob die Gruppe identisch ist
                             if (colorstring.colortyp == colortyp) {
                                 colorstring.sb.append(ch);
                             }
                             else {
                                 colorstring = new ColorString();
                                 stringListLine.colorstrings.add(colorstring);
                                 // neue Gruppe
                                 colorstring.colortyp = colortyp;
                                 colorstring.sb.append(ch);
                             }
                         }

                     }  // foreach (char ch in line) {
                 }
                 // <script type="text/javascript">  <?php  <%     </script   ?>  %>
                 if (line3.indexOf("<script") >= 0 || line3.indexOf("<?php") >= 0 || line3.indexOf("<%") >= 0) {
                     scriptBlock = true;  // checkColorTypScript
                 }
                 if (line3.indexOf("</script") >= 0 || line3.indexOf("?>") >= 0 || line3.indexOf("%>") >= 0) {
                     scriptBlock = false;  // checkColorTypScript
                 }


             }  // foreach (String line in lines) {
         }
         catch (Exception e) {
             Basis.ErrorBox("Exception im splitText\r\n" + e.toString(), "Fehler");
         }
     }
}
